package TradeGui;
import javax.swing.JPanel;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JLabel;

import misc.Message;

import org.jdom.input.*;
import org.jdom.*;
import org.jdom.output.XMLOutputter;
import org.jdom.output.Format;

import balancingGui.LoadingPanel;


import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.util.List;

public class DeleteTraderoutesPanel extends JPanel {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 8086904577785098252L;
	private JComboBox tradeDropDown;
	private JButton btDelete;
	private JLabel lbTraderoute;
	
	protected JPanel panelCenter;
	protected JPanel panelSouth;
	protected JPanel panelNorth;
		
	private File traderoutesXml = new File("TRADEROUTES.XML");
	private Document allRoutes = null;
	
	private String[] allTRoutes;
	
	public DeleteTraderoutesPanel(){
		this.setLayout(new BorderLayout());
		
		panelCenter = new JPanel();
		panelSouth = new JPanel();
		panelNorth = new JPanel();
		
		tradeDropDown = new JComboBox(getAllTradeRoutes());
		btDelete = new JButton(LoadingPanel.DELETETRADEROUTE);
		btDelete.addActionListener(new  BtDeleteActionListener());
		lbTraderoute = new JLabel("Traderoute");
		
		panelNorth.add(lbTraderoute);
		panelNorth.add(tradeDropDown);
		panelCenter.add(btDelete);
		
		this.add(panelNorth, BorderLayout.NORTH);
		this.add(panelCenter, BorderLayout.CENTER);
		this.add(panelSouth, BorderLayout.SOUTH);
		
	}
	

	
	public String[] getAllTradeRoutes(){
		SAXBuilder builder = new SAXBuilder();
		try {
			allRoutes = builder.build(traderoutesXml);
		} catch (JDOMException e) {
			e.printStackTrace();
			System.exit(-1);
		} catch (IOException e) {
			if(e.getClass()==(com.sun.org.apache.xerces.internal.impl.io.MalformedByteSequenceException.class))
				Message.showErrorMessage(e, LoadingPanel.READERROR,LoadingPanel.INVALIDFILE + '\n' +LoadingPanel.EDITORSHUTDOWN,true);
			else{
				Message.showErrorMessage(e, LoadingPanel.FILENOTFOUND,LoadingPanel.EDITORSHUTDOWN,true);				
			}
		}
		Element traderoutes = allRoutes.getRootElement();
		List tradeList = traderoutes.getChildren( "TradeRoute" );
		
		String [] tradeNames = new String [tradeList.size()];
		for (int i=0;i<tradeList.size();i++){
			Element temp = (Element)tradeList.get(i);
			tradeNames[i] = temp.getAttribute( "Name" ).getValue();
		}
		allTRoutes=tradeNames.clone();
		return tradeNames;
	}
	
	
	
	protected class BtDeleteActionListener implements ActionListener {
		public void actionPerformed(ActionEvent e)  {
			String selected = ((String)tradeDropDown.getSelectedItem());
			Element root = allRoutes.getRootElement();
			List all = root.getChildren();
			for(Object o : all){
				Element temp = (Element) o;
				if((temp.getAttributeValue("Name")).equals(selected)){
					temp.removeAttribute("Name");
					temp.setName("toBeDel");
					break;
				}
			}
			
			System.out.println(root.removeChild("toBeDel"));
			
			XMLOutputter out = new XMLOutputter(Format.getPrettyFormat() );
			try {
				out.output(allRoutes, new FileWriter(traderoutesXml));
			} catch (IOException f) {
				// TODO Auto-generated catch block
				f.printStackTrace();
			}
			tradeWriter();
		}	
	}
	
	private void tradeWriter(){
		FileOutputStream fos;
		try {
			fos = new FileOutputStream( "traderoutes.txt" );
			for(String s : allTRoutes){
				fos.write( s.getBytes() );
			}
		    fos.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	

}
