package entities;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.jdom.Element;

public class CombatHardpoint extends Hardpoint {
	
	protected LinkedList<Element> attributes= new LinkedList<Element>();
	protected LinkedList<Element> fireInacc = new LinkedList<Element>();
	private String[] hpAttributeNames = {
			"Fire_Cone_Width",
			"Fire_Cone_Height", 
			"Fire_Min_Recharge_Seconds", 
			"Fire_Max_Recharge_Seconds", 
			"Fire_Pulse_Count", 
			"Fire_Pulse_Delay_Seconds", 
			"Fire_Range_Distance",
			"Health"
	};	
	private String hpFireInName = "Fire_Inaccuracy_Distance";
	

	public CombatHardpoint(	String name,
							String[] hpAttributeNames,
							boolean isNew,String varof,Entities container) {

		super(name,isNew,hpAttributeNames,varof,container);
		this.hpAttributeNames=hpAttributeNames;
		for(String s : hpAttributeNames){
			this.attributes.add(root.getChild(s));
		}
		isCombatHp = true;
		if(this.root.getChildText("Is_Destroyable").contains("No")){
			attributes.removeLast();
			isFighterHp = true;
		}
		for(Object o : root.getChildren(hpFireInName)){
			Element e = (Element) o;
			this.fireInacc.add(e);
		}	
	}
	
	public CombatHardpoint(String name, String[] hpAttributeNames,Entities container) {

		super(name, false, hpAttributeNames, null,container);
		this.hpAttributeNames = hpAttributeNames;
		for (String s : hpAttributeNames) {
			this.attributes.add(root.getChild(s));
		}
		isCombatHp = true;
		if (this.root.getChildText("Is_Destroyable").contains("No")) {
			attributes.removeLast();
			isFighterHp = true;
		}
		for (Object o : root.getChildren(hpFireInName)) {
			Element e = (Element) o;
			this.fireInacc.add(e);
		}
	}
	
	public void setAttributes(Iterable<String> attributes){
		Iterator i = attributes.iterator();
		for (Element e : this.attributes){
			String s = i.next().toString();
//			System.out.println(s);
//			System.out.println(e.getName()+": "+e.getText());
			e.setText(s);
//			System.out.println(e.getName()+": "+e.getText());
		}
	}
	
	public void setFireInacc(Iterable<String> fireInacc){
		Iterator i = fireInacc.iterator();
		for (Element e : this.fireInacc){
			e.setText(i.next().toString());
		}
	}
	
	public void setAll(Iterable<String> values){
		Iterator i = values.iterator();
		for (Element e : this.attributes){
			String s = i.next().toString();
			System.out.println(s);
			e.setText(s);
		}
		for (Element e : this.fireInacc){
			e.setText(i.next().toString());
		}		
	}
	
	public LinkedList<Element> getAll(){
		LinkedList<Element> all = new LinkedList<Element>();
		all.addAll(attributes);
		if(!isFighterHp){
			all.addAll(fireInacc);
		}
		return all;
	}
	


	public LinkedList<Element> getFireInacc() {
		return fireInacc;
	}

	public void buildHarpoint(List<Element>attributes,List<Element>fireInacc,Integer health){
		root.setContent(attributes);
		root.setContent(fireInacc);
	}

	public String[] getHpAttributeNames() {
		return hpAttributeNames;
	}

	public String getHpFireInName() {
		return hpFireInName;
	}

	public void setHpAttributeNames(String[] hpAttributeNames) {
		this.hpAttributeNames = hpAttributeNames;
	}

	public void setHpFireInName(String hpFireInName) {
		this.hpFireInName = hpFireInName;
	}

}
