package entities;

import java.util.LinkedList;


import org.jdom.Content;
import org.jdom.Element;

import exceptions.NoSuchElementException;


import misc.ListXml;
import misc.ProcessXML;
import misc.XmlContainer;
public class Entities {
	
	
	protected LinkedList<String> shipNames =  new LinkedList<String>();
	protected LinkedList<Entity> entities = new LinkedList<Entity>();
	protected static String file ;
	protected Element trueRoot;
	private ListXml lx;
	
	public Entities(){
		
	}
	
	public Entities(String file, String[] hpAttributeNames,
			String[] attributeNames) {
		Entities.file = file;
		lx = XmlContainer.getXml(file);
		trueRoot = lx.getRoot();
		this.shipNames = lx.getElementNames();
		for (String s : shipNames) {
			entities.add(new Entity(s, file, hpAttributeNames, attributeNames,
					false, null, this));
		}
	}
	
	public Entities( String file,String[] hpAttributeNames,String[] attributeNames,Entity e){
		Entities.file = file ;
		lx = XmlContainer.getXml(file);
		this.shipNames = lx.getElementNames();
		entities.add(e);
		trueRoot = lx.getRoot();
	}

	public Entities(String string) {
		Entities.file = string;
		lx = XmlContainer.getXml(file);
		this.shipNames = lx.getElementNames();
		for (String s : shipNames) {
			entities.add(new Entity(s, file,this));
		}
		trueRoot = lx.getRoot();
	}

	public LinkedList<String> getShipNames() {
		this.shipNames=lx.getElementNames();
		return shipNames;
	}

	public LinkedList<Entity> getShips() {
		return entities;
	}
	
	public void setAttributesForMultipleShips(){
//		createXml(file);
	}
	
	public void createXml(Element root,String file){
		if (file.equalsIgnoreCase("Test.xml")) {
			trueRoot=XmlContainer.getXml("SpaceUnitsCapital.xml").getRoot();
		}
		if (file.equalsIgnoreCase("TestHp.xml")) {
			file="Hardpoints.xml";		
		}
		if(file.equalsIgnoreCase("ConfigData/HpPrototypes.xml")){
			file="Hardpoints.xml";		
		}
		trueRoot=XmlContainer.getXml(file).getRoot();	
//		Entity.printDoc(trueRoot);
		ProcessXML.writeXML(trueRoot, file);		
	}
	
	public Entity getSpecificEntity(Entity e){
		return entities.get(entities.indexOf(e));
	}
	
	
	
	
	
	public void setEntity(Entity e){
		trueRoot.addContent(e.toElement());
	}
	
	public void setMultiEntity(Entity e,String file) throws NoSuchElementException{
		trueRoot=XmlContainer.getXml(file).getRoot();
		Element temp;
		try {
			temp = ListXml.findSpecificElementWithName(e.toString(), lx.getElements());
		} catch (NoSuchElementException e1) {
			throw e1;
		}
		Element el = e.getRealAttributes().getFirst();
		Element newRoot = el.getParentElement();
		for(String s : e.getAttributeNames()){
			temp.getChild(s).setText(newRoot.getChild(s).getText());
		}
	}
	
	
	@SuppressWarnings("unchecked")
	public void setHardpoint(Entity e){
		trueRoot=XmlContainer.getXml(e.file).getRoot();
//		for(Element el : lx.getElements()){
//			String attributeValue = el.getAttributeValue("Name");
//			if(attributeValue.contains("z")||attributeValue.contains("Z"))
//			System.out.println("lx : " + attributeValue);
//		}
//		for(Element el : (List<Element>)children){
//			String attributeValue = el.getAttributeValue("Name");
//			if(attributeValue.contains("z")||attributeValue.contains("Z"))
//			System.out.println("lx.getRoot().getChildren() : " + attributeValue);
//		}
		Element temp = ListXml.findSpecificElementWithName(e.toString(),lx.getRoot().getChildren());
		Element el = e.getRealAttributes().getFirst();
		Element newRoot = el.getParentElement();
		for(String s : e.getAttributeNames()){
			temp.getChild(s).setText(newRoot.getChild(s).getText());
		}
	}
	
	public void addEntity(Entity e){
		entities.add(e);		
		trueRoot=XmlContainer.getXml(e.file).getRoot();
		Element root2 = e.getRoot();
		Content detach = root2.detach();
		trueRoot.addContent(detach);
	}
	
	public void removeAll(){
		while(entities.size()!=0)
		entities.remove();
	}
	
	
	public Entity[] toArray(){
	
		Entity[] temp =new Entity[entities.size()];
		int i=0;
		for(Entity e : entities){
			temp[i++]=e;
		}
		return temp;
	}
	
	public Entity getFirst(){
		return this.entities.getFirst();
	}

	public Element getRoot() {
		return trueRoot;
	}
	
	public static Entities toEntities(LinkedList<Entity> lle){
		Entities temp = new Entities();
		for(Entity e : lle){
			temp.shipNames.add(e.toString());
			Entities.file = e.file;
			Element parentElement = e.root.getParentElement();
			while(parentElement!=null){
				temp.trueRoot = parentElement;
				parentElement = parentElement.getParentElement();
			}			
		}
		temp.entities = lle;
		return temp;
		
		
	}
	
	public Entity getEntity(String name){
		for(Entity e : entities){
			if(e.toString().equalsIgnoreCase(name)){
				return e;
			}
		}
		return null;
	}
	
	public boolean nameAlreadyUsed(String name){
		return shipNames.contains(name)||name.equals("");
	}
	
	
	

}
