package entities;

import java.awt.Color;
import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import misc.ListXml;
import misc.Message;
import misc.XmlContainer;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;


import exceptions.ElementNotFoundException;
import exceptions.NoSuchElementException;

public class Entity {
	
	protected LinkedList<Element> attributes = new LinkedList<Element>() ;
	protected LinkedList<Element> modmulti = new LinkedList<Element>() ;
	protected LinkedList<Element> firein = new LinkedList<Element>() ;
	protected LinkedList<Element> squnits = new LinkedList<Element>() ;
	protected String[] attributeNames;
	protected LinkedList<Entity> hardpoints = new LinkedList<Entity>() ;
	protected LinkedList<Entity> abilities = new LinkedList<Entity>() ;
	protected LinkedList<String> hpNames = new LinkedList<String>();
	protected String name;
	protected Element root;
	protected Element newEntity;
	public boolean hasHP = false;
	protected String file;
	protected boolean isNew = false;
	public Entities container;
	protected String[] hpAttributeNames;
	protected ListXml lx;
	protected String variantOfExisting;
	protected Projectile projectile ;
	public boolean hasProj;
	public static  boolean alreadyDone = false;
	private static Entities fighters;
	private LinkedList<String> units;

	protected String parent;
	
	
	
	
	@SuppressWarnings("unchecked")
	public Entity(String name, String file, String[] hpAttributeNames,
			String[] attributeNames, boolean isNew, String variantOf,
			Entities container) {
		this.name = name;
		this.file = file;
		this.isNew = isNew;
		this.attributeNames = attributeNames.clone();
		this.container = container;
		this.lx = XmlContainer.getXml(file);
		if (hpAttributeNames != null) {
			this.hpAttributeNames=hpAttributeNames.clone();
		}
		if (!isNew) {
			createEntityFromFile(hpAttributeNames);
		} else {
			root = lx.getRoot();
			List<Element> children = lx.getRoot().getChildren();
			newEntity = (Element) ListXml.findSpecificElementWithName(variantOf,children).clone();
			newEntity.setAttribute("Name", name);
			root.addContent(newEntity);
			createEntityFromFile(hpAttributeNames);
		}
	}
	
	public Entity(String name){
		this.name = name;
	}
	
		
	public Entity(String name, String file,Entities container) {
		this.name = name;
		try {
			this.file = file;
			this.container = container;
		} catch (RuntimeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


	@SuppressWarnings("unchecked")
	protected void createEntityFromFile(String[] hpAttributeNames){
		List<Element> children = lx.getRoot().getChildren();
		try {
			root = ListXml.findSpecificElementWithName(name, children);
			int mmCtr=0;
			int fiCtr=0;
			
			for(String s : attributeNames){
				if(s.equals("HardPoints")&&root.getChild(s)==null&&!this.isVariantOf()){
					s="Hardpoints";
				}
				getUnitAbilities(s);
				
				if(root.getChild(s)!=null){
					Element add = root.getChild(s);
					int size = add.getChildren().size();
					
					if(!(size>0))
					add.setText(ListXml.trim(add.getText()));
					this.attributes.add(add);				
				}
				else{
					if(this.isVariantOf()){
						Element child;
						try {
							try {
								child = (Element) ListXml.findSpecificElementWithName(variantOfExisting, children).getChild(s).clone();
								this.attributes.add(child);
							} catch (RuntimeException e) {
							}
						} catch (NoSuchElementException e) {
							child = null;
						}
					}
				}
				if(s.equals("Fire_Inaccuracy_Distance")){
					try {
						LinkedList<Element> findall = ListXml.findAllElements(s, this.root);
						Element element=null;
						try {
							element = findall.get(fiCtr++);
							firein.add(element);
						} catch (RuntimeException e) {
							attributes.add(new Element("Fire_Inaccuracy_Distance"));
							continue;
						}
					} catch (NoSuchElementException e) {
						attributes.add(new Element("Fire_Inaccuracy_Distance"));
						continue;
					}
					continue;
				}
				if(s.equals("Mod_Multiplier")){
					try {
						LinkedList<Element> findall = ListXml.findAllElements(s, this.root);
						Element element=null;
						try {
							element = findall.get(mmCtr++);
							modmulti.add(element);
						} catch (RuntimeException e) {						
						}
					} catch (NoSuchElementException e) {
					}
					continue;
				}
				if(s.equals("Squadron_Units")){
					try {
						LinkedList<Element> findall = ListXml.findAllElements(s, this.root);
						try {
							squnits.addAll(findall);
						} catch (RuntimeException e) {						
						}
					} catch (NoSuchElementException e) {
					}
					continue;
				}
//				else{
//					if(this.isVariantOf()){
//						Element child;
//						try {
//							LinkedList<Element> findall = ListXml.findAllElements(s, ListXml.findSpecificElementWithName(variantOfExisting, children)).getChild(s);
//						} catch (NoSuchElementException e) {
//							child = null;
////							e.printStackTrace();
////							Message.showErrorMessage(e, "Lesefehler", "Element "+s+" konnte nicht gefunden werden", false);
//						}
//						if(child!=null)
//						this.attributes.add(child);
//					}
//				}
			}
			initFighters();
			Element child = null;
			Element child2 = null;
			try {
				child = ListXml.findSpecificElement("HardPoints",attributes);
			} catch (NoSuchElementException e) {
				if(this.isVariantOf()){
					Element child3 = null;
					try {
						child3 = ListXml.findSpecificElementWithName(variantOfExisting, children).getChild("HardPoints");
					} catch (NoSuchElementException e1) {
						
					}
					if(child3!=null)
					this.attributes.add(child3);
				}
			}
			try {
				child2 = ListXml.findSpecificElement("Fire_Projectile_Type",attributes);
			} catch (NoSuchElementException e) {
				if(this.isVariantOf()){
					Element child3=null;
					try {
						child3 = ListXml.findSpecificElementWithName(variantOfExisting, children).getChild("Fire_Projectile_Type");
					} catch (NoSuchElementException e1) {
					}
					if(child3!=null)
					this.attributes.add(child3);
				}
			}
			if (child2 == null) {
				try {
					child2 = ListXml.findSpecificElement("Projectile_Types", attributes);
				} catch (NoSuchElementException e) {
					if (this.isVariantOf()) {
						Element child3=null;
						try {
							child3 = ListXml.findSpecificElementWithName(variantOfExisting, children).getChild(
									"Fire_Projectile_Type");
						} catch (NoSuchElementException e1) {
						}
						if (child3 != null)
							this.attributes.add(child3);
					}
				}
			}
			if ((child != null)) {
				hasHP = true;
				String[] temp = child.getText().split(",");
				for (String s : temp) {
					this.hpNames.add((ListXml.trim(s)));
				}

				String string = hpNames.get(0);
				boolean b = string.equalsIgnoreCase("Hardpoints");
				if (!b) {
					for (String s : hpNames) {
						Hardpoint temp2 = new Hardpoint(s, this.container,this.toString());
						hardpoints.add(temp2);
					}
				} else {
					hasHP = false;
				}
			}
			if ((child2 != null)) {
				String temp = child2.getText();
				Projectile temp2 = new Projectile(temp, this.container);
				projectile = temp2;
				hasProj = true;

				
			}	
		} catch (NoSuchElementException e2) {
			if(!name.equalsIgnoreCase(""))
			Message.showErrorMessage(e2, "Element nicht gefunden", "Folgendes Element wurde beim Initialisieren in der Datei "+"\n"+this.file+" nicht gefunden :", true);
			
		}
		
	}
	

	
	

	private void getUnitAbilities(String s) {
		boolean equalsIgnoreCase=false;
		boolean b=false;
		try {
			equalsIgnoreCase = s.equalsIgnoreCase("unit_abilities_data");
			b = root.getChild(s).getChild("Unit_Ability")!=null;
		} catch (RuntimeException e1) {				
		}
		if(equalsIgnoreCase&&b){
			abilities.add(new UnitAbility(root.getChild(s).getChild("Unit_Ability")));
		}
		
	}

	@SuppressWarnings("unchecked")
	public String getFaction(){
		Element temp;
		try {
			temp = ListXml.findSpecificElement("Affiliation", root.getChildren());
		} catch (NoSuchElementException e) {
//			Entity e = container.lx.findSpecificElementWithName(lx.findSpecificElement("V, i), i)
			return "unknown";
		}
		return temp.getText();
	}
	

	
	public LinkedList<String> getAttributes(){
		LinkedList<String> result = new LinkedList<String>();
		for(Element e : attributes){
			result.add(e.getText());
		}
		return result;
	}
	
	public LinkedList<Element> getRealAttributes(){
		return attributes;
	}
	
	public void setAttributes(LinkedList<String> values){
		Iterator<String> i = values.iterator();
		for (Element e : this.attributes){
			String toString = i.next().toString();
			e.setText(toString);
		}		
	}
	
	public void setMultipleAttributes(LinkedList<String> values){
		Iterator<String> i = values.iterator();
		for (Element e : this.attributes){
			e.setText(i.next().toString());
		}		
	}
	
	public void setAttribute(String name,LinkedList<String> name2, Element it){
		Element temp;
		
		try {
			if(!name.equals("Mod_Multiplier")){
				temp = getAttribute(name).getFirst();
			}
			else{
				temp = it;
			}
		} catch (ElementNotFoundException e) {
			temp = new Element(name);
			attributes.add(temp);
		}
		String temp2 = "";
		for (int i = 0; i < name2.size(); i++) {
			if (i < name2.size() - 1)
				temp2 = temp2.concat(name2.get(i) + ",");
			else
				temp2 = temp2.concat(name2.get(i));
		}
		temp.setText(temp2);
		temp.detach();
		root.addContent(temp);
		
	}
	
	public void setAttribute(String name,String name2, Element it){
		Element temp;
		if(name.equals("HardPoints")){
			System.out.println();
		}
		try {
			if(!name.equals("Fire_Inaccuracy_Distance")){
				temp = getAttribute(name).getFirst();
			}
			else{
				temp = it;
			}
		} catch (ElementNotFoundException e) {
			temp = new Element(name);
			attributes.add(temp);
		}
		temp.setText(name2);	
		temp.detach();
		root.addContent(temp);
		
	}
	
	
	
	
	
	public LinkedList<Entity> getHardpoints(){
		return hardpoints;
	}
	public LinkedList<String> getHardpointNames(){
		return hpNames;
	}
	
	public String[] getAttributeNames() {
		return attributeNames;
	}

	public String toString(){
		return this.name;
	}
	
	public Entity getSpecificHardpoint(Entity h){
		return hardpoints.get(hardpoints.indexOf(h));
	}
	public void addHardpoint(Hardpoint h,LinkedList<String> name2){
		hasHP=true;
		hardpoints.add(h);
		hpNames.add(h.toString());
		while(name2.contains("Hardpoints")){
			name2.remove("Hardpoints");			
		}
		Element temp = ListXml.findSpecificElement("Hardpoints", attributes);
		if(name2.size()>1){
			String temp2 ="";
			for(int i=0;i<name2.size();i++){
				if(i<name2.size()-1)
					temp2=temp2.concat(name2.get(i)+",");
				else
					temp2=temp2.concat(name2.get(i));
			}
			temp.setText(temp2);
			
		}
		else{
			temp.setText(name2.get(0));			
		}
	}
	
	public void setAttributeNames(String[] attributeNames) {
			this.attributeNames = attributeNames;
	//		bliblablu
		}

	public int getHpPos(){
		for(int i=0;i<attributeNames.length;i++){
			if(attributeNames[i].equalsIgnoreCase("Hardpoints"))
				return i+1;
		}
		return -1;
	}
	
	public int getAttributePos(String name){
		for(int i=0;i<attributeNames.length;i++){
			if(attributeNames[i].equalsIgnoreCase(name))
				return i;
		}
		return -1;
	}


	public String getFile() {
		return this.file;
	}
	
	public boolean isVariantOf(){
		try {
			Element findSpecificElement = root.getChild("Variant_Of_Existing_Type");
			variantOfExisting = findSpecificElement.getText();
			return true;
		} catch (java.lang.NullPointerException e) {
			return false;
		}
	}
	
	public Element getRoot(){
		return this.root;
	}
	
	public Projectile getProjectile(){
		return this.projectile;
	}
	
	public int getDps(){
		@SuppressWarnings("unused")
		double endDamage=0.0,reloadMin = 0.0 ,reloadAvg=0.0, reloadMax = 0.0, damage = 0.0, pulse = 0.0, arearange =0.0,areadamage =0.0;
		if(this.hasHP){
			for(Entity h : hardpoints){
				h = (Hardpoint) h;
				endDamage = endDamage + h.getDps();
			}
			return (int)endDamage;
		}
		if(this.squnits!=null&&!file.equalsIgnoreCase("SpaceUnitsFighters.xml")){
			processSqUnits();
			for(String s : units){
				Entity en = fighters.getEntity(s);
				int dps = en.getDps();
				endDamage =  endDamage + dps;
			}
			return (int) endDamage;
		}
		if (projectile != null) {
			damage = calcValues("Projectile_Damage", 0.0, projectile
					.getRealAttributes());
			arearange = calcValues("Projectile_Blast_Area_Range", 1.0,
					projectile.getRealAttributes());
			areadamage = calcValues("Projectile_Blast_Area_Damage", 0.0,
					projectile.getRealAttributes());
			reloadAvg = calcValues("Projectile_Fire_Recharge_Seconds", 1.0, this
					.getRealAttributes());
			pulse = calcValues("Fire_Pulse_Count", 1.0, this
					.getRealAttributes());

			damage = damage + (areadamage) / (arearange); // Schaden =
															// Projektilschaden
															// +
															// Flchenschaden/Flche
			endDamage = damage * pulse / reloadAvg;
			return (int) endDamage;
		
		}		
		else {
			return 0;
		}
	}
	

	
	public int calcHealth(){
		double shield=0.0,refresh=0.0,health=0.0,endHealth=0;
		if(squnits!=null){
			for(String s : units){
				endHealth =  endHealth + fighters.getEntity(s).calcHealth();
			}
			return (int) endHealth;
		}
		shield = calcValues("Shield_Points", 0.0, this.getRealAttributes());
		refresh = calcValues("Shield_Refresh_Rate", 0.0, this.getRealAttributes());
		health = calcValues("Tactical_Health",0.0,this.getRealAttributes());
		return (int)(shield+refresh+health);
	}
	
	protected double calcValues(String s, double d,Iterable<Element> i){
		try {
			d = Double.parseDouble(ListXml.findSpecificElement(s, i).getText());
		} catch (NumberFormatException e) {
			return d;
		} catch (NoSuchElementException e) {
			return d;
		}
		return d;
	}

	
	@SuppressWarnings("unchecked")
	public void setAbility(Element ability){
		Element temp;
		try {
			temp = root.getChild("Unit_Abilities_Data");
		} catch (NoSuchElementException e) {
			System.out.println("new");
			temp = new Element("Unit_Abilities_Data");
			temp.setAttribute("SubObjectList", "Yes");
		}
		abilities.add(new UnitAbility(ability));
		ability.removeAttribute("Name");
		ability.detach();
		temp.addContent(ability);
		temp.detach();
		root.addContent(temp);
//		printDoc(root);

	}
	
	public static void printDoc(Element root){
		Document doc = root.getDocument();
		XMLOutputter out = new XMLOutputter( Format.getPrettyFormat() ); 
		try {
			out.output( doc, System.out );
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public LinkedList<Element> getAttribute(String name) throws ElementNotFoundException{
		LinkedList<Element> temp = new LinkedList<Element>();
		boolean modMulti = name.equalsIgnoreCase("Mod_Multiplier")&&!(this.modmulti.size() == 0);
		boolean fireMulti = name.equalsIgnoreCase("Fire_Inaccuracy_Distance")&&!(this.firein.size() == 0);
		if (modMulti) {
			return this.modmulti;
		}
		if(fireMulti){
			return this.firein;
		}
		
		if(!modMulti&&!fireMulti) {
			for (Element e : attributes) {
				if (e.getName().equalsIgnoreCase(name))
					temp.add(e);
			}
			if (!(temp.size() == 0))
				return temp;
		}
		throw new ElementNotFoundException(name);
	}
	
	public Element toElement(){
		this.root.detach();
		return root;
	}

	public LinkedList<Entity> getAbilities() {
		return abilities;
	}
	
	public void initFighters(){
//		if(!alreadyDone){
//			alreadyDone=true;
//			fighters = new Entities("SpaceUnitsFighters.xml",LoadingPanel.Filters.get(0).getFilter(),LoadingPanel.Filters.get(1).getFilter());
//		}
	}
	
	public String[] getAbilityNames(){
		String[] temp = new String[abilities.size()];
		for(int i=0;i<abilities.size();i++){
			temp[i] = abilities.get(i).toString();
		}
		return temp;
	}
	
	private void processSqUnits() {
		units = new LinkedList<String>();
		for(Element e : squnits){
			for(String s : ListXml.trimArray(e.getText().split(","))){
					units.add(s);
				
			}
		}
		
	}
	
	public String getSqUnits(){
		String temp = "";
//		for(String s : units)
//			temp=temp+s;
		return temp;
	}

	public void setName(String name2) {
		this.root.setAttribute("Name", name2);
		this.name = name2;
		
	}

	public void setFile(String string) {
		this.file = string;
		
	}
	
	public Color getColor(String s) {
		String[] sa;
		try {
			sa = this.getAttribute(s).getFirst().getText().split(",");
			int[] ia = new int[sa.length];
			for(int i =0;i<sa.length;i++)
			ia[i] = Integer.parseInt(sa[i]);
			return new Color(ia[0],ia[1],ia[2],ia[3]);
		} catch (ElementNotFoundException e) {
			return null;
		}
	}
	
	public Entity clone(){
		Entity newE = new Entity(this.name);
		newE.attributeNames = this.attributeNames.clone();
		newE.attributes = new LinkedList<Element>();
		for(Element e : attributes){
			newE.attributes.add((Element)e.clone());
		}
		newE.container = this.container;
		newE.file = new String(this.file.toCharArray());
		newE.firein = new LinkedList<Element>();
		for(Element e : attributes){
			newE.firein.add((Element)e.clone());
		}
		newE.hardpoints = new LinkedList<Entity>();
		for(Entity e : hardpoints){
			newE.hardpoints.add(e.clone());
		}
		newE.lx = this.lx;
		try {
			newE.parent = new String(this.parent.toCharArray());
			newE.projectile = (Projectile) this.projectile.clone();
			newE.variantOfExisting = new String(this.variantOfExisting.toCharArray());
		} catch (RuntimeException e1) {
		}	
		newE.root = (Element) this.root.clone();	
		return newE;
		
	}
	
	



}
