package entities;

import java.util.LinkedList;


import org.jdom.Element;



import balancingGui.LoadingPanel;


public class Hardpoint extends Entity{
	
	
	public boolean isFighterHp = false;
	public boolean isCombatHp = false;
	public boolean isNormalHp = false;
	
	
	@SuppressWarnings("unchecked")
	
	public Hardpoint(String name,Entities container,String parent){
		super(name,"Hardpoints.xml",null,LoadingPanel.Filters.get(3).getFilter(),false,null,container);
	}

	public Hardpoint(String name, boolean isNew, String[] filter, String varOf,
			Entities container) {
		super(name, "Hardpoints.xml", null, filter, isNew, varOf, container);

	}
	
	public boolean isFighterHp(){
		return (this.root.getChildText("Is_Destroyable").contains("No"));
	}
	
	public boolean isCombatHp(){
		return (this.root.getChild("Fire_Cone_Width")!=null);
	}
	
	public boolean isNormalHp(){
		return 
		!isFighterHp()
		&&
		!isCombatHp();
	}
	
	public String toString(){
		return this.name;
	}
	
	
	
	
	public LinkedList<Element> getRealHardpointAttributes(){
		LinkedList <Element> result = new LinkedList<Element>();
		if(this.isCombatHp()&&!this.isFighterHp()){
			CombatHardpoint ch=(CombatHardpoint)this;
			for(Element e : ch.getAll()){
				result.add(e);
			}
			return result;			
		}
		if(this.isFighterHp()){
			CombatHardpoint ch=(CombatHardpoint)this;
			for(Element e : ch.getRealAttributes()){
				result.add(e);
			}
			return result;
		}
		else{
			NormalHardpoint nh = (NormalHardpoint)this;
			result.add(nh.getRealHealth());
			return result;
		}
	}
	
	
	public int getDps(){
		double endDamage=0.0,reloadMin = 0.0 ,reloadAvg=0.0, reloadMax = 0.0, damage = 0.0, pulse = 0.0, arearange =0.0,areadamage =0.0;
		if (projectile != null) {
			damage = calcValues("Projectile_Damage", 0.0, projectile
					.getRealAttributes());
			arearange = calcValues("Projectile_Blast_Area_Range", 1.0,
					projectile.getRealAttributes());
			areadamage = calcValues("Projectile_Blast_Area_Damage", 0.0,
					projectile.getRealAttributes());
			reloadMin = calcValues("Fire_Min_Recharge_Seconds", 1.0, this
					.getRealAttributes());
			reloadMax = calcValues("Fire_Max_Recharge_Seconds", 1.0, this
					.getRealAttributes());
			pulse = calcValues("Fire_Pulse_Count", 1.0, this
					.getRealAttributes());

			damage = damage + (areadamage) / (arearange); // Schaden =
															// Projektilschaden
															// +
															// Flchenschaden/Flche
			reloadAvg = reloadMax + reloadMin / 2;
			endDamage = damage * pulse / reloadAvg;
			return (int) endDamage+1;
		} else {
			return 0;
		}
	}
	
	public int calcHealth(){
		double shield=0.0,refresh=0.0,health=0.0;
		shield = calcValues("Shield_Points", 0.0, this.getRealAttributes());
		refresh = calcValues("Shield_Refresh_Rate", 0.0, this.getRealAttributes());
		health = calcValues("Health",0.0,this.getRealAttributes());
		return (int)(shield+refresh+health);
	}
	
			
			
	

}
