package entityPanels;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import entities.Entity;


import balancingGui.EntityFrame;
import balancingGui.LoadingPanel;


public class CreateEntityPanel extends EntityPanel {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -1700091071122182772L;

	public CreateEntityPanel (String file, JFrame rootFrame){
		super(file, rootFrame,true);
		this.setLayout(new BorderLayout());
		createBuildShip();
	}
	
	public CreateEntityPanel(String file,boolean isNew,Entity e) {
		super(file, isNew, e);
	}
	
	
	protected void createBuildShip(){
		panelNorth = new JPanel();
		panelCenter = new JPanel();
		panelSouth = new JPanel();
		
		panelNorth.setLayout(new GridLayout(0, 2));
		panelCenter.setLayout(new GridLayout(0, 2));
		panelSouth.setLayout(new GridLayout(0, 2));
		
		
		btSave = new JButton("Speichern");
		btSave.addActionListener(new BtCreateNewActionListener());
		
		
		tfShipName = new JTextField(15);
		lbShipName = new JLabel("Schiffsname");
		lbVof = new JLabel("Variant_Of");
		vofDropDown = new JComboBox(entityList.toArray());
		vofDropDown.addItemListener(new VofDropDownSelectActionListener());
		
		jl.setFont(new Font("Serif", Font.BOLD, 20));

		panelNorth.add(lbShipName);
		panelNorth.add(tfShipName);
		panelNorth.add(lbVof);
		panelNorth.add(vofDropDown);
		panelNorth.add(jl);
		
		createBuildShipData();
		resetFields(entityTextFields);

		
		this.add(panelNorth, BorderLayout.NORTH);
		this.add(panelCenter, BorderLayout.CENTER);
		this.add(panelSouth, BorderLayout.SOUTH);
		this.setVisible(true);
	}
	
	protected void createBuildShipData() {
		for (String s : LoadingPanel.Filters.get(2).getFilter()) {
			entityLabels.add(new JLabel(s));
			JTextField temp = new JTextField(s);
			temp.setToolTipText(s);
			entityTextFields.add(temp);			
		}
		Iterator it1 = entityLabels.iterator(), it2 = entityTextFields.iterator();
		while (it2.hasNext()) {
			panelSouth.add((JLabel) it1.next());
			panelSouth.add((JTextField) it2.next());
		}
		panelSouth.add(btSave);
		
	}
	
	protected boolean isValidName(){
		return !tfShipName.getText().equals("");
	}
	
	protected class BtCreateNewActionListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			currentShip = new Entity(
					tfShipName.getText(), 
					file, 
					LoadingPanel.Filters.get(0).getFilter(), 
					LoadingPanel.Filters.get(2).getFilter(), 
					true, 
					vofDropDown.getSelectedItem().toString(),
					shs
			);
			if (isValidName()) {
				currentShip.setAttributes(getFieldContents(entityTextFields));
				shs.addEntity(currentShip);
				JOptionPane.showMessageDialog(null, "Erfolgreich gespeichert!");
			} else {
				JOptionPane.showMessageDialog(null, "Ungltiger Name");
			}
			
		}

	}
}
