package entityPanels;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import misc.Message;

import org.jdom.Element;

import entities.Entity;
import entities.Hardpoint;


import balancingGui.EntityFrame;
import balancingGui.LoadingPanel;


public class CreateHpPanel extends CreateEntityPanel {
	
	
	private Entity type;
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -1700091071122182772L;

	public CreateHpPanel(String file,Entity e, boolean b) {
		super(file,true,e);
		this.setLayout(new BorderLayout());
		createBuildShip();
	}
	

	
	protected void createBuildShip(){
		panelNorth = new JPanel();		
		panelNorth.setLayout(gbl);
		
		
		btSave = new JButton("Hardpoint hinzufgen");
		btSave.addActionListener(new BtCreateHpActionListener());
		btSave.addActionListener(new BtUpdateHpActionListener());
		
		tfShipName = new JTextField(15);
		lbShipName = new JLabel("Hardpointname");
		lbVof = new JLabel("Hardpointart");
		String[] options = {"LaserHp","JaegerHp","NormalHp","ZweitwaffenHp"};
		LinkedList<Entity> lle = new LinkedList<Entity>();
		for(String s : options){
			String[] filter = LoadingPanel.Filters.get(3).getFilter();
			lle.add(new Entity(s,"Hardpoints.xml",null,filter,false,null,shs));
		}
		type = (Entity)JOptionPane.showInputDialog(null, 
	              "Hardpointtyp", 
	              "Bitte den Typ des Hardpoints whlen", 
	              JOptionPane.QUESTION_MESSAGE, 
	              null, lle.toArray(), 
	              lle.toArray()[0] );
//		vofDropDown = new JComboBox(type);
//		vofDropDown.addItemListener(new VofDropDownSelectActionListener());
		
		jl.setFont(new Font("Serif", Font.BOLD, 20));

		
		addComponent(panelNorth, gbl, lbShipName, gridx, gridy, 1, 1, 1.0, 1.0);
		addComponent(panelNorth, gbl, tfShipName, gridx+1, gridy++, 1, 1, 1.0, 1.0);
		addComponent(panelNorth, gbl, lbVof, gridx, gridy, 1, 1, 1.0, 1.0);
		addComponent(panelNorth, gbl, new JLabel(type.toString()), gridx+1, gridy++, 1, 1, 1.0, 1.0);
		addComponent(panelNorth, gbl, jl, gridx, gridy++, 1, 1, 1.0, 1.0);
		layoutOffset=gridy;
		createBuildShipData();
//		resetFields(entityTextFields);

		
		this.add(panelNorth, BorderLayout.NORTH);
		this.setVisible(true);
	}
	
	protected boolean decrpyt(String string){
		return string.equalsIgnoreCase("yes");
	}
	
	protected void createBuildShipData() {
		setHpFields();
		Iterator <JLabel>it1 = entityLabels.iterator();Iterator <JComponent>it2 = entityFields.iterator();
		while (it2.hasNext()) {
			addComponent(panelNorth, gbl, it1.next(), gridx, gridy, 1, 1, 1.0, 1.0);
			addComponent(panelNorth, gbl, it2.next(), gridx+1, gridy++, 1, 1, 1.0, 1.0);
		}
//		for(int i=0;i<positions.length;i++){
//			attrPositions[i]=newHp.getAttributePos(positions[0]);
////			attrBt[i] = new JButton(";
//		}
////		newHp.getAttributePos(")
		addComponent(panelNorth, gbl, btSave, 2, 0, 1, 1, 1.0, 1.0);

		
	}
	
	private void setHpFields(){
		for (Element e : type.getRealAttributes()) {
			String attributeName = e.getName();
			entityLabels.add(new JLabel(attributeName));
			JComponent temp =null;
			boolean hpType = attributeName.equals("Type");
			boolean destroyable = attributeName.equals("Is_Destroyable");
			boolean targetable = attributeName.equals("Is_Targetable");
			boolean expPart = attributeName.equals("Death_Explosion_Particles");
			boolean deathSfx = attributeName.equals("Death_Explosion_SFXEvent");
			boolean damageDecal = attributeName.equals("Damage_Decal");
			boolean damageParticle = attributeName.equals("Damage_Particles");
			boolean fireSfx = attributeName.equals("Fire_SFXEvent");
			boolean damageType = attributeName.equals("Damage_Type");
			boolean fireProj = attributeName.equals("Fire_Projectile_Type");
			boolean fireRock = attributeName.equals("Fire_When_In_Rocket_Attack_Mode");
			boolean fireNorm = attributeName.equals("Fire_When_In_Normal_Attack_Mode");
			
			
			if(hpType){
				temp = new JComboBox(LoadingPanel.hpTypes);
				((JComboBox) temp).setSelectedItem(e.getText());
			}
			if(targetable){
				temp = new JCheckBox("Angreifbar");
				((JCheckBox) temp).setSelected(decrpyt(e.getText()));
			}
			if(destroyable){
				temp = new JCheckBox("Zerstrbar");
				((JCheckBox) temp).setSelected(decrpyt(e.getText()));
			}
			if(fireRock){
				temp = new JCheckBox("Feuert als Sekundrwaffe");
				((JCheckBox) temp).setSelected(decrpyt(e.getText()));
			}
			if(fireNorm){
				temp = new JCheckBox("Feuert als Primrwaffe");
				((JCheckBox) temp).setSelected(decrpyt(e.getText()));
			}
			if(expPart){
				temp = new JComboBox(LoadingPanel.explosionParticles);
				((JComboBox) temp).setSelectedItem(e.getText());
			}
			if(deathSfx){
				temp = new JComboBox(LoadingPanel.hpDeathSfx);
				((JComboBox) temp).setSelectedItem(e.getText());
			}
			if(damageDecal){
				temp = new JComboBox(LoadingPanel.hpDamageDecal);
				((JComboBox) temp).setSelectedItem(e.getText());
			}
			if(damageParticle){
				temp = new JComboBox(LoadingPanel.hpDamageParticle);
				((JComboBox) temp).setSelectedItem(e.getText());
			}
			if(damageType){
				temp = new JComboBox(LoadingPanel.DamageTypes);
				((JComboBox) temp).setSelectedItem(e.getText());
			}
			if(fireProj){
//				for(String s: LoadingPanel.hpFireProj){
//					type.getProjectiles();
//				}
//				temp = new JComboBox(type.getProjectiles().toArray());
//				((JComboBox) temp).setSelectedItem(e.getText());
			}
			if(fireSfx){
				temp = new JComboBox(LoadingPanel.hpFireSfx);
				((JComboBox) temp).setSelectedItem(e.getText());
			}
			if(
					!hpType&&!targetable&&!destroyable&&!expPart&&!deathSfx&&
					!damageDecal&&!damageParticle&&!damageType&&!fireProj&&!fireSfx&&
					!fireRock&&!fireNorm
			){
				temp = new JTextField(e.getText());				
			}
			entityFields.add(temp);			
		}
		btDamage = new JButton ("Neuen Typ hinzufgen");
		btDamage.addActionListener(new btDamageActionListener());
		addComponent(panelNorth, gbl, btDamage, 2, this.getPositionOf("Damage_Type",entityLabels), 1, 1, 1.0, 1.0);
	}
	
	private LinkedList<String> getHpFields(){
		LinkedList<String> temp = new LinkedList<String>();
		for(JComponent jc : entityFields){
			if (jc instanceof JTextField) {
				JTextField temp2 = (JTextField) jc;
				temp.add(temp2.getText());
			}
			if (jc instanceof JComboBox) {
				JComboBox temp2 = (JComboBox) jc;
				temp.add((String)temp2.getSelectedItem());
			}
			if (jc instanceof JCheckBox) {
				JCheckBox temp2 = (JCheckBox) jc;
				temp.add(encrypt(temp2.isSelected()));
			}
		}
		return temp;
	}
	
	private String encrypt (boolean isSelected){
		if(isSelected){
			return "Yes";
		}
		else{
			return "No";
		}
	}
	
	protected class BtCreateHpActionListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			if (isValidName()) {
				newHp = new Hardpoint(tfShipName.getText(), true,
						LoadingPanel.Filters.get(3).getFilter(), type.toString(), shs);

				newHp.setAttributes(getHpFields());
				JOptionPane.showMessageDialog(null, "Erfolgreich gespeichert!");
				// System.out.println(currentShip);
				currentShip
						.addHardpoint(newHp, currentShip.getHardpointNames());
			} else {
				JOptionPane.showMessageDialog(null, "Ungltiger Name");
			}
			
		}

	}
	
	protected class btDamageActionListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			
		}

	}
	
	

}
