package entityPanels;



import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import misc.Message;

import org.jdom.Element;

import xmlFilter.XmlFilter;


import entities.Entities;
import entities.Entity;
import entities.Hardpoint;
import balancingGui.EntityFrame;
import balancingGui.LoadingPanel;


public abstract class EntityPanel extends JPanel {

	protected JPanel panelCenter;
	protected JPanel panelSouth;
	protected JPanel panelNorth;
	protected JButton btSave;
	protected JButton btEditHp;
	protected JButton btCreateHp;
	protected LinkedList<JLabel> entityLabels = new LinkedList<JLabel>();
	protected JComboBox entitysDropDown;
	protected JComboBox hpDropDown;
	protected Entity currentShip;
	protected LinkedList<JComponent>  entityFields = new LinkedList<JComponent>();
	protected LinkedList<JTextField> entityTextFields = new LinkedList<JTextField>();
	protected Entity newShip;
	protected static String file;
	public static LinkedList<Entity> entityList;
	protected static String VariantOf = new String ("Variant_Of_Existing_Type");
	protected static JLabel jl = new JLabel("Daten");
	protected boolean Multi = false;
	protected Entities shs;
	protected JTextField tfShipName;
	protected JLabel lbShipName;
	protected JLabel lbVof;
	protected JComboBox vofDropDown;
	protected String[] hpNames;
	protected Entity currentHp;
	protected Hardpoint newHp;
	protected GridBagLayout gbl = new GridBagLayout();
	protected static int gridx=0,gridy = 0;
	protected JLabel name = new JLabel("Name");
	protected JLabel blank = new JLabel();
	protected static String[] positions = {"Fire_Projectile_Type","Damage_Type"};
	protected static int[] attrPositions = new int[positions.length];
	protected static JButton[] attrBt = new JButton[positions.length];
	protected static int layoutOffset=0;
	protected Entity currentProj;
	protected JButton btDamage;
	protected JButton btProj;



	public EntityPanel(String file,JFrame rootFrame,boolean isNew){
		gridx=0;gridy=0;
		EntityPanel.file=file;
		shs = new Entities(EntityPanel.file, LoadingPanel.Filters.get(0).getFilter(), LoadingPanel.Filters.get(2).getFilter());
		entityList = shs.getShips();
		System.gc();

	}

	public EntityPanel(String file,JFrame rootFrame){
		gridx=0;gridy=0;
		EntityPanel.file=file;
		LinkedList<XmlFilter> linkedList = LoadingPanel.Filters;
		XmlFilter xmlFilter = linkedList.get(0);
		String[] filter = xmlFilter.getFilter();
		shs = new Entities(EntityPanel.file, filter, linkedList.get(1).getFilter());
		entityList = shs.getShips();
		System.gc();		
	}

	public EntityPanel(String file,JFrame rootFrame,Entity e){
		gridx=0;gridy=0;
		EntityPanel.file=file;
		shs = new Entities(EntityPanel.file, null, LoadingPanel.Filters.get(0).getFilter(), e);
		currentShip = shs.getSpecificEntity(e);
		entityList = shs.getShips();
		System.gc();


	}

	public EntityPanel(String file,boolean isNew,Entity e){
		gridx=0;gridy=0;
		EntityPanel.file=file;
		currentShip = e;
		shs = new Entities(EntityPanel.file, null, LoadingPanel.Filters.get(3).getFilter(), currentShip);

		System.gc();


	}

	public EntityPanel(Entity currentShip, boolean Multi){
		gridx=0;gridy=0;
		this.setLayout(gbl);
		this.Multi=Multi;
		this.currentShip = currentShip;
		shs = currentShip.container;
		this.setVisible(true);
	}


	public static void addComponent(Container cont, GridBagLayout gbl, Component c,
			int x, int y, int width, int height, double weightx, double weighty) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.weightx = weightx;
		gbc.weighty = weighty;
		gbl.setConstraints(c, gbc);
		cont.add(c);
	} 







	protected void createShipData(Entity entity) {
		int hpPos = currentShip.getHpPos();
		for (Element e : entity.getRealAttributes()) {
			if(!Multi)
//				System.out.println(this+":"+e.getName());
				entityLabels.add(new JLabel(e.getName()));


			JTextField temp = new JTextField(e.getText(), 20);
			temp.setToolTipText(e.getName());
			entityTextFields.add(temp);

		}
		Iterator it1 = entityLabels.iterator(), it2 = entityTextFields.iterator();
		hpDropDown = new JComboBox();
		while (it2.hasNext()) {
			if(!Multi)
				addComponent(panelNorth, gbl, (JLabel) it1.next(), gridx, gridy, 1, 1, 1.0, 1.0);

			addComponent(panelNorth, gbl, (JTextField) it2.next(), gridx+1, gridy++, 1, 1, 1.0, 1.0);
		}
		if (entity.hasHP) {
			updateHpDropDown(entity);
			panelNorth.remove(entityTextFields.get(hpPos-1));				
			addComponent(panelNorth, gbl, hpDropDown, gridx+1, hpPos, 1, 1, 1.0, 1.0);
			if(!Multi)
				addComponent(panelNorth, gbl, btEditHp  , gridx+2, hpPos, 1, 1, 1.0, 1.0);
		}
		else {
			updateHpDropDown(entity);
			hpDropDown.setEnabled(false);
			btEditHp.setEnabled(false);
			addComponent(panelNorth, gbl, hpDropDown, gridx+1, hpPos, 1, 1, 1.0, 1.0);
			if(!Multi)
				addComponent(panelNorth, gbl, btEditHp  , gridx+2, hpPos, 1, 1, 1.0, 1.0);

		}
	}

	protected void updateHpDropDown(Entity en) {
		if (hpDropDown != null) {
			hpDropDown.removeAllItems();
			for (Entity e : en.getHardpoints()) {
				hpDropDown.addItem(e);
			}
		}
		else{
			hpDropDown = new JComboBox(en.getHardpoints().toArray());
		}
	}

	protected void updateShipData(Entity entity) {
		int hpPos = currentShip.getHpPos();
		Iterator it2 = entityTextFields.iterator();
		for (String s : entity.getAttributes()) {
			JTextField tf = (JTextField) it2.next();
			tf.setText(s);
		}
		if (entity.hasHP) {
			updateHpDropDown(entity);
			gbl.removeLayoutComponent(entityTextFields.get(hpPos-1));
			hpDropDown.setEnabled(true);
			btEditHp.setEnabled(true);
		}
		else {
			updateHpDropDown(entity);
			hpDropDown.setEnabled(false);
			btEditHp.setEnabled(false);

		}
		this.validate();
	}

	protected LinkedList<String> getFieldContents(LinkedList<JTextField> fields) {
		LinkedList<String> temp = new LinkedList<String>();
		for (JTextField tf : fields) {
			temp.add(tf.getText());
		}
		return temp;
	}

	protected void checkPanel() {
	}

	protected void resetFields(LinkedList<JTextField> tf) {
		for (JTextField t : tf) {
			t.setText("");
		}
	}



	protected class BtSaveActionListener implements ActionListener {
		public void actionPerformed(ActionEvent arg0) {
			currentShip.setAttributes(getFieldContents(entityTextFields));
			if (currentShip instanceof Hardpoint) {
				shs.setHardpoint(currentShip);			
			}
			else{
				shs.setEntity(currentShip);
			}
			JOptionPane.showMessageDialog(null, "Erfolgreich gespeichert!");
		}
	}

	protected class BtEditHpActionListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			Hardpoint selectedItem = (Hardpoint)hpDropDown.getSelectedItem();
			try {
				currentHp = currentShip.getSpecificHardpoint(selectedItem);
				EntityFrame temp = new EntityFrame("Hardpoints.xml",currentHp,false);
				temp.setVisible(true);
			} catch (RuntimeException e) {
				Message.showMessage("Fehler", "Keine Hardpoints gefunden");
			}
		}

	}

	protected class btProjActionListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
//			JComboBox jcb = (JComboBox)entityFields.get(getPositionOf("Fire_Projectile_Type",entityLabels)-layoutOffset);
//			Entity selectedItem = (Entity)jcb.getSelectedItem();
////			try {
//			currentProj = currentHp.getSpecificProjectile(selectedItem);
//			EntityFrame temp = new EntityFrame("Projectiles.xml",currentProj,false);
//			temp.setVisible(true);
////			} catch (RuntimeException e) {
////			Message.showMessage("Fehler", "Keine Hardpoints gefunden");
////			}
		}

	}

	protected class ShipsDropDownSelectActionListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			Entity selectedItem = (Entity)entitysDropDown.getSelectedItem();
			currentShip = shs.getSpecificEntity(selectedItem);
			updateShipData(currentShip);

		}
	}







	protected class VofDropDownSelectActionListener implements ItemListener {

		public void itemStateChanged(ItemEvent arg0) {
			currentShip = (Entity) vofDropDown.getSelectedItem();
			updateShipData(currentShip);
			checkPanel();
		}
	}

	public LinkedList<JTextField> getShipTextFields() {
		return entityTextFields;
	}

	public Entities getEntities(){
		return this.shs;
	}

	protected class BtUpdateHpActionListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
		}

	}

	public String toString(){
		return "EntityPanel"+":"+this.file+":"+shs+":"+currentShip;
	}

	protected int getPositionOf (String name, LinkedList<JLabel> i){
		for (JLabel jl : i){
			String name2 = jl.getText();
			if(name2.equalsIgnoreCase(name)){
				return i.indexOf(jl)+layoutOffset;
			}
		}
		return -1;
	}



}
