package entityPanels;

import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.jdom.Element;

import balancingGui.LoadingPanel;


import entities.Entities;
import entities.Entity;



public class MultiEntityPanel extends EntityPanel {
	

	/**
	 * 
	 */
	private static final long serialVersionUID = -4114298129268658270L;
	private LinkedList<String> factionList = new LinkedList<String>();
	private LinkedList<Entity> multiEntityList = new LinkedList<Entity>();
	private LinkedList<LinkedList<JCheckBox>> checkList = new LinkedList<LinkedList<JCheckBox>>();
	private LinkedList<LinkedList<Entity>> entityDList = new LinkedList<LinkedList<Entity>>();
	private JButton btOpen;
	private JButton btSave;
	private JDialog dialog = new JDialog();
	private JFrame rootFrame;
	private JTextField [][] tfFields;
	private boolean isValid = true;
	private LinkedList<String> invalidShips = new LinkedList<String>();
//	private LinkedList<Entities> shss = new LinkedList<Entities>();
	

	public MultiEntityPanel(String file,JFrame rootFrame) {
		super(file, rootFrame);
		this.setLayout(gbl);
		this.setVisible(false);
		this.rootFrame=rootFrame;
		rootFrame.setVisible(false);
//		if(file.equalsIgnoreCase("SpaceUnitsCapital.xml")||file.equalsIgnoreCase("SpaceUnitsFrigates.xml")||file.equalsIgnoreCase("SpaceUnitsCorvettes.xml")){
//			String[] files = {"SpaceUnitsCapital.xml","SpaceUnitsFrigates.xml","SpaceUnitsCorvettes.xml"};
//			createDialog(files);
//		}
//		else{
			String[] files = { file };
			createDialog(files);
//		}

	}
	
	protected void createMultiShip(Entity currentShip){
		panelNorth = new JPanel();
		panelNorth.setLayout(gbl);
		addComponent(panelNorth, gbl, new JLabel(currentShip.toString()),gridx,gridy,1,1,1.0,1.0);
		createShipData(currentShip);
		addComponent(this, gbl, panelNorth,0,0,1,1,1.0,1.0);
	}
	
	private void createDialog(String[] files){
		dialog.setTitle("Whlen sie die zu vergleichenden Einheiten");
		btOpen = new JButton("Vergleichen");
		btOpen.addActionListener(new btOpenListener());
		btOpen.setToolTipText("Gewhlte Schiffe vergleichen");


		int x=0;
		int y=0;
		dialog.setLayout(gbl);

		for (String ent : files) {
			Entities lists = new Entities(ent, null, LoadingPanel.Filters.get(1).getFilter());

			for (Entity s : lists.getShips()) {
				JCheckBox tempBox = new JCheckBox(s.toString(), false);
				Entity tempShip = s;
				String temp2 = s.getFaction();
				if (!factionList.contains(temp2)) {
					LinkedList<JCheckBox> jcbll = new LinkedList<JCheckBox>();
					LinkedList<Entity> sll = new LinkedList<Entity>();
					factionList.add(temp2);
					checkList.add(jcbll);
					entityDList.add(sll);
				}
				int i = 0;
				for (String st : factionList) {
					if (temp2.equals(st)) {
						checkList.get(i).add(tempBox);
						entityDList.get(i).add(tempShip);
					}
					i++;
				}
			}
			
		}
			int z = 0;
			for (String s : factionList) {
				addComponent(dialog, gbl, new JLabel(s), z++, y, 1, 1, 0, 0);
			}
			y++;
//			System.out.println("x:" + x + "y:" + y + "z:" + z);
			x = 0;
			for (LinkedList<JCheckBox> ll : checkList) {
				z = y;
				for (JCheckBox jcb : ll) {
					addComponent(dialog, gbl, jcb, x, z++, 1, 1, 0, 0);
				}
				x++;
			}
		addComponent(dialog,gbl,btOpen,0,20,1,1,0,0);
		dialog.pack();
		dialog.setAlwaysOnTop(true);
		dialog.setVisible(true);
		
		
	}
	
	
	public void showPanel(){
		this.setVisible(true);
		rootFrame.pack();
		rootFrame.setVisible(true);
	}
	
	private class btOpenListener implements ActionListener{

		@SuppressWarnings("unchecked")
		public void actionPerformed(ActionEvent e) {
			deleteUncheked();
			createPanels();
			
			
		}
		
	}
	
	@SuppressWarnings("unchecked")
	private void deleteUncheked(){
		Iterator entityIt = entityDList.iterator();
		for (LinkedList<JCheckBox> lljcb : checkList) {
			LinkedList<Entity> next = (LinkedList<Entity>) entityIt.next();
			LinkedList<Entity> tempShip = next;
			for(JCheckBox jcb : lljcb){
				if(!jcb.isSelected()){
					String del = jcb.getText();
					Entity toDel = null;
					for(Entity s : tempShip){
						String eq = s.toString();
						if(eq.equals(del)){
							toDel = s;						
						}							
					}
					if(toDel!=null)tempShip.remove(toDel);		
				}
			}
		}
		for(LinkedList<Entity> lls : entityDList){
			for(Entity s : lls){
				multiEntityList.add(s);
			}
		}
	}
	
	public void createPanels(){
		currentShip = multiEntityList.getFirst();
		
		int mListSize = multiEntityList.size();
		int attributeSize = currentShip.getRealAttributes().size();
		int hpPos = 0;
		int gridx =0 , gridy =1;
		for (Element e : currentShip.getRealAttributes()) {
			String name2 = e.getName();
			if(!name2.equals("HardPoints")){
				addComponent(this, gbl, new JLabel(name2), gridx, gridy++, 1, 1, 1.0, 1.0);			
			}
			else{
				hpPos = gridy-1;
			}
		}
		gridx =0 ; gridy =0;
		for (Entity e : multiEntityList){
			addComponent(this,gbl,new JLabel(e.toString()),++gridx,gridy,1,1,1.0,1.0);
		}
		System.out.println(hpPos);
		tfFields = new JTextField[mListSize][attributeSize];
		for (int i = 0; i < mListSize; i++) {
			currentShip = multiEntityList.get(i);
			LinkedList<String> attributes = currentShip.getAttributes();
			if(attributes.size()<attributeSize){
				isValid=false;
				invalidShips.add(currentShip.toString());
				System.out.println(currentShip.toString()+":"+attributes.size()+":"+attributeSize);
				String[] attributeNames = currentShip.getAttributeNames();
				for(String s : attributeNames)
				System.out.println(s);
				
				continue;
			}
			for (int j = 0; j < attributeSize-1; j++) {
					String string;
//					try {
						string = attributes.get(j);
//					} catch (java.lang.IndexOutOfBoundsException e1) {
//						break;
//					}
					tfFields[i][j] = new JTextField(string);
					if (!(j == hpPos)) {
					addComponent(this, gbl, tfFields[i][j], i + 1, j + 1, 1, 1,
							1.0, 1.0);
					}
					else{
						tfFields[i][j] = new JTextField(string);
//						try {
							string = attributes.get(++j);
//						} catch (java.lang.IndexOutOfBoundsException e1) {
//							break;
//						}
						tfFields[i][j] = new JTextField(string);
						addComponent(this, gbl, tfFields[i][j], i+1,j, 1, 1,
								1.0, 1.0);
					}
			}
		}
		btSave = new JButton("Speichern");
		btSave.addActionListener(new BtSaveActionListener());
		addComponent(this, gbl, btSave, mListSize+1, attributeSize+1, 1, 1, 1.0, 1.0);
		dialog.dispose();
		this.validate();
		this.setVisible(true);
		rootFrame.pack();
		rootFrame.setVisible(true);
	}
	
	protected LinkedList<LinkedList<String>> getFieldContents(JTextField[][] fields) {
		LinkedList<LinkedList<String>> temp2 = new LinkedList<LinkedList<String>>();
		for (JTextField[] tfa : fields) {
			LinkedList<String> temp = new LinkedList<String>();
			for(JTextField tf : tfa ){
				if(tf==null){
					temp.add("NA");
				}
				System.out.println(temp);
				System.out.println(tf.getText());
				temp.add(tf.getText());
			}
			temp2.add(temp);
		}
		return temp2;
	}
	
	protected class BtSaveActionListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
//			String[] files = {"SpaceUnitsCapital.xml","SpaceUnitsFrigates.xml","SpaceUnitsCorvettes.xml"};
			int i =0;
			if (!isValid) {
				JOptionPane
						.showMessageDialog(
								null,
								"Folgende Einheiten besitzen ein VariantOf der nicht in der gleichen Datei "+"\n"+
										"wie die Einheit selbst ist, bitte diesen Fehler korrigieren"+"\n"+ invalidShips);
			}
			LinkedList<LinkedList<String>> fieldContents = getFieldContents(tfFields);
			for (Entity currentShip : multiEntityList) {
				currentShip.setAttributes(fieldContents.get(i++));
				System.out.println(currentShip);
				shs.setEntity(currentShip);
//				shs = currentShip.container;
//				if(!shss.contains(shs)){
//					shss.add(shs);
//				}
//				for(int j=0;j<files.length;){
//					try {
//						shs.setMultiEntity(currentShip,files[j]);
//						j=file.length();
//					} catch (NoSuchElementException e) {
//						j++;
//					}
//				}
			}
//			System.out.println(shss);
			JOptionPane.showMessageDialog(null, "Erfolgreich gespeichert!");
		}

	}
	
	
	
	
}
