package entityPanels;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JPanel;

import xmlFilter.XmlFilter;

import balancingGui.EntityFrame;
import balancingGui.LoadingPanel;

import entities.Entity;
import entityPanels.EntityPanel.btProjActionListener;


public class SingleEntityPanel extends EntityPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 9042194310395539622L;

	public SingleEntityPanel(String file) {
		super(file, null);
		this.setLayout(gbl);
		createSingleShip(file, LoadingPanel.Filters.get(0), LoadingPanel.Filters.get(1));
	}
	
	public SingleEntityPanel(Entity currentShip,boolean b) {
		super(currentShip,b);
//		createMultiShip(currentShip);
	}
	
	public SingleEntityPanel(String file,Entity e) {
		super(file, null, e);
		this.setLayout(gbl);
		createSingleShip(file, LoadingPanel.Filters.get(0), LoadingPanel.Filters.get(0));
	}

	protected void createSingleShip(String file, XmlFilter hpFilter,
			XmlFilter entityFilter) {

		panelNorth = new JPanel();
		panelNorth.setLayout(gbl);
		btSave = new JButton("Speichern");
		btSave.addActionListener(new BtSaveActionListener());
		btEditHp = new JButton("Hardpoint bearbeiten");
		btEditHp.addActionListener(new BtEditHpActionListener());
		btCreateHp = new JButton("Hardpoint erstellen");
		btCreateHp.addActionListener(new BtCreateHpActionListener());
		btProj = new JButton ("Projektil bearbeiten");
		btProj.addActionListener(new btProjActionListener());

		jl.setFont(new Font("Serif", Font.BOLD, 20));

		

		entitysDropDown = new JComboBox(entityList.toArray());
		entitysDropDown.addActionListener(new ShipsDropDownSelectActionListener());

		Entity selectedItem = (Entity)entitysDropDown.getSelectedItem();
		currentShip = shs.getSpecificEntity(selectedItem);
		
		

		addComponent(panelNorth, gbl, name, 			gridx	,gridy	,1, 1, 1.0	, 1.0);
		addComponent(panelNorth, gbl, entitysDropDown, 	gridx+1	,gridy	,1, 1, 1.0  , 1.0);
		addComponent(panelNorth, gbl, btSave, 			gridx+2	,gridy	,1, 1, 1.0  , 1.0);
		addComponent(panelNorth, gbl, blank, 			gridx+3	,gridy++,1, 1, 1.0  , 1.0);
		if(file.equals("Hardpoints.xml")){
			addComponent(panelNorth, gbl, btProj, 2, this.getPositionOf("Fire_Projectile_Type",entityLabels), 1, 1, 1.0, 1.0);
		}
		createShipData(currentShip);
		
		if(!file.equals("Hardpoints.xml"))
		addComponent(panelNorth, gbl, btCreateHp,		gridx	,gridy	,1, 1, 1.0	, 1.0);
		addComponent(this, gbl, panelNorth, 0, 0, 1, 1, 1.0, 1.0);
		this.setVisible(true);
	}
	
	protected class BtCreateHpActionListener implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			Entity selectedItem = (Entity)entitysDropDown.getSelectedItem();
			currentShip = shs.getSpecificEntity(selectedItem);
			EntityFrame temp = new EntityFrame("Hardpoints.xml",currentShip,true);
			temp.addWindowListener(new WindowCloseListener());
			temp.setVisible(true);
		}

	}
	
	private class WindowCloseListener implements WindowListener{

		public void windowActivated(WindowEvent e) {
		}

		public void windowClosed(WindowEvent e) {			
		}

		public void windowClosing(WindowEvent e) {
			updateShipData(currentShip);		
		}

		public void windowDeactivated(WindowEvent e) {
		}

		public void windowDeiconified(WindowEvent e) {
		}

		public void windowIconified(WindowEvent e) {
		}
		public void windowOpened(WindowEvent e) {
		}		
	}


}
