package eventChain;

import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

import events.Event;

public class MovieEvent {
	public Element root = new Element ("Story");
	private String movie;
	private String chapter;
	private String dialog;
	private String branch;
	private boolean perp;
	private Event event;
	private Event start = new Event ("Universal_Story_Start");
	
	public MovieEvent (String movie,String chapter, String dialog,boolean perp){
		this.movie=movie;
		this.chapter=chapter;
		this.dialog=dialog;
		this.perp = perp;
		event = new Event ("event_for_"+movie+"_movie");
	}
	
	public LinkedList<Element> getPrereq1 (){
		LinkedList<Element> ll = new LinkedList<Element>();
		ll.add(new Element ("Prereq").addContent(start.getName()));
		return ll;
	}
	
	public LinkedList<Element> getPrereq2 (){
		LinkedList<Element> ll = new LinkedList<Element>();
		ll.add(new Element ("Prereq").addContent(event.getName()));
		return ll;
	}
	
	public void buildConstruct(String object, Integer amount , String filter){
		event.buildStoryConstruct(object, amount, filter);
		buildReward();
		root.addContent(event.buildEvent(
				this.getPrereq1(), branch, perp));
	}
	
	public void buildConquer(String planet, String filter){
		event.buildStoryConquer(planet, filter);
		buildReward();
		root.addContent(event.buildEvent(
				this.getPrereq1(), branch, perp));
	}
	
	public void buildDestroy(String object, Integer amount, String planet, String destroyer){
		event.buildStoryDestroy(object, planet, amount, destroyer);
		buildReward();
		root.addContent(event.buildEvent(
				this.getPrereq1(), branch, perp));
	}
	
	public void buildReward (){
		event.buildMovie(movie);
	}
	
	public void buildText(){
		Event message = new Event("Message_for_"+movie+"_movie");
		
		message.buildStoryTrigger();
		root.addContent(message.buildEvent(
				this.getPrereq2(), branch, perp, chapter, dialog));		
	}
	
	public Element getRoot(){
		return this.root;
	}
	
	public void writeXML(){
		Document allEvents = new Document(this.getRoot());
		XMLOutputter out = new XMLOutputter(Format.getPrettyFormat() );
		try {
			out.output(allEvents, new FileWriter("MovieEvent.xml"));
		} catch (IOException f) {
			// TODO Auto-generated catch block
			f.printStackTrace();
		}
	}
}
