package eventChain;

import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

import misc.CompareType;
import misc.Filter;
import misc.Flag;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

import events.Event;

public class SectorControl {
	
	public Element root = new Element ("Story");
	
	public SectorControl (String[] planets, String reward,String spawnPlanet, int amount, boolean repeatable, boolean spawn){
		String branch;
		if(!spawn){
			branch = reward + "_branch";
			LinkedList<Event> dprereqs= new LinkedList<Event>();
			LinkedList<Event> iprereqs= new LinkedList<Event>();
			Event start = new Event ("Universal_Story_Start");
			Event setFlag = new Event(reward+"_flag");
			Event disable = new Event("Disable_"+reward);
			Event enable  = new Event("Enable_"+reward);
			Flag flag = new Flag(reward+"_flag", 0);
			
			
			dprereqs.add(start);
			
			setFlag.buildStoryTrigger();
			setFlag.buildSetFlag(flag, Integer.parseInt(flag.value));
			root.addContent(setFlag.buildEvent(start, branch, false));
			
			
			int i=1;
			
			for (String planet : planets){
				Event increase = new Event(reward+"_build_"+i);						//Increase Counter
				Event decrease = new Event(reward+"_build_"+(i+planets.length));	//Decrease Counter
				Event disable_e = new Event ("Disable_"+reward+"_build_"+i);		//Disable the Increas
				Event enable_e = new Event ("Enable_"+reward+"_build_"+i);			//Enable the Increase
				Event disable_e2 = new Event ("Disable_"+reward+"_build_"+(i+planets.length));	//Disable Decrease
				Event enable_e2 = new Event ("Enable_"+reward+"_build_"+(i+planets.length));	//Enable Decrease
				LinkedList<Element> pre_disable = new LinkedList<Element>();// List for initially Disabling the Decreases
				pre_disable.add(new Element("Prereq").addContent(decrease.getName())); 
				pre_disable.add(new Element ("Prereq").addContent(start.getName()));
				increase.buildStoryConquer(planet, Filter.FRIENDLY_ONLY);
				increase.buildIncFlag(flag, 1);
				decrease.buildStoryConquer(planet, Filter.FRIENDLY_ONLY);
				decrease.buildIncFlag(flag, -1);
				disable_e.buildStoryTrigger();
				disable_e.buildDisableEvent(increase, true);
				enable_e.buildStoryTrigger();
				enable_e.buildDisableEvent(increase, false);
				disable_e2.buildStoryTrigger();
				disable_e2.buildDisableEvent(decrease, true);
				enable_e2.buildStoryTrigger();
				enable_e2.buildDisableEvent(decrease, false);
				root.addContent(increase.buildEvent(setFlag, branch, true));
				root.addContent(decrease.buildEvent(setFlag, branch, true));
				root.addContent(disable_e.buildEvent(increase, branch, true));
				root.addContent(enable_e.buildEvent(decrease, branch, true));
				root.addContent(disable_e2.buildEvent(pre_disable, branch, true));
				root.addContent(enable_e2.buildEvent(increase, branch, true));
				dprereqs.add(decrease); // add prerequesites for disabling the Object
				iprereqs.add(increase); // add prereqs for enabling the object
				i++;
			}
			LinkedList<Element> dpres =new LinkedList<Element>();
			for (Event e : dprereqs){
				Element temp = new Element ("Prereq");
				temp.addContent(e.getName());
				dpres.add(temp);
			}
			LinkedList<Element> ipres =new LinkedList<Element>();
			for (Event e : iprereqs){
				Element temp = new Element ("Prereq");
				temp.addContent(e.getName());
				ipres.add(temp);
			}
			
			enable.buildStoryFlag(flag.name, planets.length, CompareType.EQUAL_TO);
			enable.buildBuildable(false, reward);
			root.addContent(enable.buildEvent(ipres, branch, true));
			
			disable.buildStoryFlag(flag.name, planets.length, CompareType.LESS_THAN);
			disable.buildBuildable(true, reward);
			root.addContent(disable.buildEvent(dpres, branch, true));
			
			
			
			if(!repeatable){
				Event itemBuilt = new Event(reward+"_built");
				itemBuilt.buildStoryConstruct(reward, 1, Filter.FRIENDLY_ONLY);
				itemBuilt.buildLockUnit(reward);
				root.addContent(itemBuilt.buildEvent(new Event(""), branch, false));
				Event disableBranch = new Event("disable_"+branch);
				disableBranch.buildStoryTrigger();
				disableBranch.buildDisableBranch(branch, true);
				root.addContent(disableBranch.buildEvent(itemBuilt, "", false));
				
			}
		}
		else{
			branch = "Spawn_"+ reward + "_branch";
			LinkedList<Event> prereqs= new LinkedList<Event>();
			Event start = new Event ("Universal_Story_Start");
			Event setFlag = new Event("Spawn_"+reward+"_flag");
			Event spawnEvent  ;
			Flag flag = new Flag("Spawn_"+reward+"_flag", 0);
			
			prereqs.add(start);
			
			setFlag.buildStoryTrigger();
			setFlag.buildSetFlag(flag, Integer.parseInt(flag.value));
			root.addContent(setFlag.buildEvent(start, branch, false));
			
			
			
			for (String planet : planets){
				int i=1;
				Event increase = new Event(reward+"_spawn_"+i);
				Event decrease = new Event(reward+"_spawn_"+(i+planets.length));
				Event disable_e = new Event ("Disable_"+reward+"_spawn_"+i);
				Event enable_e = new Event ("Enable_"+reward+"_spawn_"+i);
				Event disable_e2 = new Event ("Disable_"+reward+"_spawn_"+(i+planets.length));
				Event enable_e2 = new Event ("Enable_"+reward+"_spawn_"+(i+planets.length));
				increase.buildStoryConquer(planet, Filter.FRIENDLY_ONLY);
				increase.buildIncFlag(flag, 1);
				decrease.buildStoryConquer(planet, Filter.ENEMY_ONLY);
				decrease.buildIncFlag(flag, -1);
				disable_e.buildStoryTrigger();
				disable_e.buildDisableEvent(increase, true);
				enable_e.buildStoryTrigger();
				enable_e.buildDisableEvent(increase, false);
				disable_e2.buildStoryTrigger();
				disable_e2.buildDisableEvent(decrease, true);
				enable_e2.buildStoryTrigger();
				enable_e2.buildDisableEvent(decrease, false);
				root.addContent(increase.buildEvent(setFlag, branch, true));
				root.addContent(decrease.buildEvent(setFlag, branch, true));
				root.addContent(disable_e.buildEvent(increase, branch, true));
				root.addContent(enable_e.buildEvent(decrease, branch, true));
				root.addContent(disable_e2.buildEvent(decrease, branch, true));
				root.addContent(enable_e2.buildEvent(increase, branch, true));
				prereqs.add(increase); // add prerequesites
			}
			LinkedList<Element> pres =new LinkedList<Element>();
			for (Event e : prereqs){
				Element temp = new Element ("Prereq");
				temp.addContent(e.getName());
				pres.add(temp);
			}
			LinkedList<Element> spawns= new LinkedList<Element>();
			spawnEvent = new Event("Spawn_"+reward+"#"+1);
			spawnEvent.buildStoryFlag(flag.name, planets.length, CompareType.EQUAL_TO);
			spawnEvent.buildSpawnUnit(reward, spawnPlanet);
			root.addContent(spawnEvent.buildEvent(start, branch, false));
			Event lastSpawn = null;
			for (int i=1; i<amount;i++){
				Event temp = new Event("Spawn_"+reward+"#"+(i+1));
				temp.buildStoryTrigger();
				temp.buildSpawnUnit(reward, spawnPlanet);
				spawns.add(temp.buildEvent(spawnEvent, branch, false));
				lastSpawn=temp;
			}
			root.addContent(spawns);
			if(!repeatable){
				Event disableBranch = new Event("disable_"+branch);
				disableBranch.buildStoryTrigger();
				disableBranch.buildDisableBranch(branch, true);
				root.addContent(disableBranch.buildEvent(lastSpawn, branch, false));
				
			}
		}
		
	}
	
	public Element getRoot(){
		return this.root;
	}
	
	public void writeXML(){
		Document allEvents = new Document(this.getRoot());
		XMLOutputter out = new XMLOutputter(Format.getPrettyFormat() );
		try {
			out.output(allEvents, new FileWriter("SectorControl.xml"));
		} catch (IOException f) {
			// TODO Auto-generated catch block
			f.printStackTrace();
		}
	}
}
