package eventGui;

import eventChain.MovieEvent;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import balancingGui.LoadingPanel;

import misc.Filter;

public class MovieEventPanel extends JPanel {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -5728086627575972910L;

	private JButton btSave;
	
	private JComboBox eventTypes;
	private JComboBox filters;
	
	private JLabel lbEvents;
	private JLabel lbPlanet;
	private JLabel lbObject;
	private JLabel lbFilter;
	private JLabel lbAmount;
	private JLabel lbMovie;
	private JLabel lbChapter;
	private JLabel lbDialog;
	
	private JCheckBox perpeCheckbox;
	
	private JTextField tfPlanet;
	private JTextField tfObject;
	private JTextField tfAmount;
	private JTextField tfMovie;
	private JTextField tfChapter;
	private JTextField tfDialog;
	
	private JPanel panelCenter;
	private JPanel panelSouth;
	private JPanel panelNorth;
	
	private boolean perp=false;
	
	public MovieEventPanel (String[] eventTypes){
		
		this.setLayout(new BorderLayout());
		btSave = new JButton(LoadingPanel.CREATEEVENT);
		btSave.addActionListener(new BtSaveActionListener());
		
		lbEvents = new JLabel("Events");
		lbMovie = new JLabel ("Movie");
		lbChapter = new JLabel (LoadingPanel.EVENTCHAPTER);
		lbDialog = new JLabel (LoadingPanel.DIALOGFILE);
		
		tfMovie = new JTextField (10);
		tfChapter = new JTextField (10);
		tfDialog = new JTextField (10);
		
		this.eventTypes = new JComboBox (eventTypes);
		this.eventTypes.addItemListener(new DropDownSelectActionListener() );
		panelNorth = new JPanel();
		panelCenter = new JPanel();
		panelSouth = new JPanel();
		
		panelNorth.add(lbEvents);
		panelNorth.add(this.eventTypes);
		panelCenter.add(lbMovie);
		panelCenter.add(tfMovie);
		panelCenter.add(lbChapter);
		panelCenter.add(tfChapter);
		panelCenter.add(lbDialog);
		panelCenter.add(tfDialog);
		panelNorth.add(btSave);
		

		this.add(panelNorth, BorderLayout.NORTH);
		this.add(panelCenter, BorderLayout.CENTER);
		checkPanel();	
			
				
		
		
		
	}
	
	private void checkPanel(){
		this.remove(panelSouth);
		if(eventTypes.getSelectedItem().equals("Conquer")){
			panelSouth = new JPanel();
			
			System.out.println("zing");
			lbPlanet = new JLabel("Planet");
			lbFilter = new JLabel("Wer erobert?");
			
			tfPlanet = new JTextField(10);
			filters = new JComboBox(Filter.getFilters());
			perpeCheckbox = new JCheckBox(LoadingPanel.PERPETUAL);
			
			perpeCheckbox.addItemListener(new CheckBoxItemListener());
			
			panelSouth.add(lbPlanet);
			panelSouth.add(tfPlanet);
			
			panelSouth.add(lbFilter);
			panelSouth.add(filters);
			
		}
		if(eventTypes.getSelectedItem().equals("Construct")){
			panelSouth = new JPanel();
			
			System.out.println("zing");
			lbObject = new JLabel("Objekt");
			lbAmount = new JLabel("Anzahl");
			lbFilter = new JLabel("Wer baut?");
			
			tfObject = new JTextField(10);
			tfAmount = new JTextField(10);
			filters = new JComboBox(Filter.getFilters());
			perpeCheckbox = new JCheckBox(LoadingPanel.PERPETUAL);
			
			perpeCheckbox.addItemListener(new CheckBoxItemListener());
			
			panelSouth.add(lbObject);
			panelSouth.add(tfObject);
			
			panelSouth.add(lbAmount);
			panelSouth.add(tfAmount);
			
			panelSouth.add(lbFilter);
			panelSouth.add(filters);
			
			panelSouth.add(perpeCheckbox);
			
		}
		if(eventTypes.getSelectedItem().equals("Destroy")){
			panelSouth = new JPanel();
			
			System.out.println("zing");
			lbObject = new JLabel("Objekt");
			lbAmount = new JLabel("Anzahl");
			lbPlanet = new JLabel("Planet");
			lbFilter = new JLabel("Wer zerstrt?");
			
			tfPlanet = new JTextField(10);
			tfObject = new JTextField(10);
			tfAmount = new JTextField(10);
			filters = new JComboBox(Filter.getFilters());
			perpeCheckbox = new JCheckBox(LoadingPanel.PERPETUAL);
			
			perpeCheckbox.addItemListener(new CheckBoxItemListener());
			
			panelSouth.add(lbObject);
			panelSouth.add(tfObject);
			
			panelSouth.add(lbAmount);
			panelSouth.add(tfAmount);
			
			panelSouth.add(lbPlanet);
			panelSouth.add(tfPlanet);
			
			panelSouth.add(lbFilter);
			panelSouth.add(filters);
			
			panelSouth.add(perpeCheckbox);
			
		}
		this.setVisible(false);
		this.add(panelSouth, BorderLayout.PAGE_END);
		this.repaint();
		this.updateUI();
		this.setVisible(true);
	}
	
	
	private class DropDownSelectActionListener implements ItemListener{

		public void itemStateChanged(ItemEvent arg0) {
			checkPanel();				
		}		
	}
	
	private class CheckBoxItemListener implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			if(e.getStateChange() == 1) {
				perp=true;
			}
			else {
				perp=false;
			}
		}		
	}
	
	protected class BtSaveActionListener implements ActionListener {
		public void actionPerformed(ActionEvent e)  {
			MovieEvent me = new MovieEvent(
					tfMovie.getText(),
					tfChapter.getText(),
					tfDialog.getText(),
					perp);
			if(eventTypes.getSelectedItem().equals("Conquer")){
				me.buildConquer(tfPlanet.getText(), (String)filters.getSelectedItem());
				me.buildText();
				tfPlanet.setText("");
			}
			if(eventTypes.getSelectedItem().equals("Construct")){
				me.buildConstruct(	tfObject.getText(),
									Integer.parseInt(tfAmount.getText()),(
									String)filters.getSelectedItem());
				me.buildText();
				tfObject.setText("");
				tfAmount.setText("");
			}
			if(eventTypes.getSelectedItem().equals("Destroy")){
				me.buildDestroy(	tfObject.getText(),
									Integer.parseInt(tfAmount.getText()),
									tfPlanet.getText(),
									(String)filters.getSelectedItem());
				me.buildText();
				tfObject.setText("");
				tfAmount.setText("");
				tfPlanet.setText("");
			}
			me.writeXML();
			tfMovie.setText("");
			tfChapter.setText("");
			tfDialog.setText("");
		
		}
	}
}
