package eventGui;


import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import balancingGui.LoadingPanel;


import eventChain.SectorControl;

public class SectorControlEventPanel extends JPanel {
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1364239017885497808L;

	private JButton btSave;
		
	private JLabel lbPlanets;
	private JLabel lbReward;
	private JLabel lbSpawnPlanet;
	private JLabel lbAmount;
	
	private JCheckBox perpeCheckbox;
	private JCheckBox spawnCheckbox;
	
	private JTextArea taPlanets;
	private JTextField tfReward;
	private JTextField tfSpawnPlanet;
	private JTextField tfAmount;
	
	private JPanel panelCenter;
	private JPanel panelSouth;
	private JPanel panelNorth;
	
	private boolean perp=false,spawn=false;
	
	public SectorControlEventPanel (){
		
		this.setLayout(new BorderLayout());
		
		btSave = new JButton(LoadingPanel.CREATEEVENT);
		btSave.addActionListener(new BtSaveActionListener());
				
		lbPlanets = new JLabel(LoadingPanel.REQPLANETS);
		lbReward = new JLabel(LoadingPanel.REWARDOBJECT);
		lbSpawnPlanet= new JLabel("Spawn-Planet");
		lbAmount= new JLabel(LoadingPanel.AMOUNTOFUNITS);
		
		
		
		taPlanets = new  JTextArea(10,10);
		tfReward = new JTextField(10);
		tfSpawnPlanet = new JTextField(10);
		tfAmount = new JTextField(10);
		

		tfSpawnPlanet.setEditable(false);
		tfAmount.setEditable(false);
		
		perpeCheckbox = new JCheckBox(LoadingPanel.PERPETUAL);
		spawnCheckbox = new JCheckBox("SpawnEvent?");
		
		perpeCheckbox.addItemListener(new CheckBoxItemListener());
		spawnCheckbox.addItemListener(new CheckBoxItemListener2());
		spawnCheckbox.addActionListener(new checkListener());
		
		panelNorth = new JPanel();
		panelCenter = new JPanel();
		panelSouth = new JPanel();
		
		panelNorth.add(lbPlanets);
		panelNorth.add(taPlanets);
		
		panelCenter.add(lbReward);
		panelCenter.add(tfReward);
		panelCenter.add(lbSpawnPlanet);
		panelCenter.add(tfSpawnPlanet);
		panelCenter.add(lbAmount);
		panelCenter.add(tfAmount);
		panelCenter.add(perpeCheckbox);
		panelCenter.add(spawnCheckbox);
		
		panelSouth.add(btSave);
		
		this.add(panelNorth, BorderLayout.NORTH);
		this.add(panelCenter, BorderLayout.CENTER);
		this.add(panelSouth, BorderLayout.SOUTH);
		
		
		
	}
	
	private void resetFields(){
		taPlanets.setText("");
		tfReward.setText(""); 
		tfSpawnPlanet.setText("");
		tfAmount.setText("");
		perp=false;
		spawn=false;
	}
	
	private class checkListener implements ActionListener{

		public void actionPerformed(ActionEvent e) {
			if(perpeCheckbox.isSelected()) {
				perp=true;
				tfSpawnPlanet.setEditable(true);
				tfAmount.setEditable(true);
			}
			else {
				perp=false;
				tfSpawnPlanet.setEditable(false);
				tfAmount.setEditable(false);
			}
		}
		
	}
	
	private class CheckBoxItemListener implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			if(e.getStateChange() == 1) {
				perp=true;
				tfSpawnPlanet.setEditable(true);
				tfAmount.setEditable(true);
			}
			else {
				perp=false;
				tfSpawnPlanet.setEditable(false);
				tfAmount.setEditable(false);
			}
		}		
	}
	
	private class CheckBoxItemListener2 implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			if(e.getStateChange() == 1) {
				spawn=true;
			}
			else {
				spawn=false;
			}
		}		
	}
	
	protected class BtSaveActionListener implements ActionListener {
		public void actionPerformed(ActionEvent e)  {
			String planets =taPlanets.getText();
			int amount;
			if(tfAmount.getText().equals("")){
				 amount = 1;
			}
			else{
				amount=Integer.parseInt(tfAmount.getText());
			}
			SectorControl sc = new SectorControl(
				planets.split("\n"), 
				tfReward.getText(), 
				tfSpawnPlanet.getText(),
				amount,
				perp,spawn
			);
			sc.writeXML();
			resetFields();
		
		}
	}
	

}
