package events;


import java.util.LinkedList;
import java.util.List;

import misc.Flag;

import org.jdom.Element;

import rewardTypes.*;

import eventTypes.*;

public class Event {
	private Element type= new Element("Event");
	private List <Element> event;
	private List <Element> reward;
	private Element	Prereq = new Element("Prereq");
	private Element Story_Chapter = new Element ("Story_Chapter");
	private Element Story_Dialog = new Element ("Story_Dialog");
	private Element Branch = new Element ("Branch");
	private Element Perpetual = new Element ("Perpetual");
	
	public Event (String name){
		type.setAttribute("Name", name);		
	}
	
	public Element buildEvent(Event pre, String branch, Boolean perp){
		type.addContent(event);
		type.addContent(reward);
		type.addContent(Prereq.addContent(pre.getName()));
		type.addContent(Branch.addContent(branch));
		type.addContent(Perpetual.addContent(perp.toString()));
		return type;
		
	}
	
	public Element buildEvent(LinkedList<Element> pre, String branch, Boolean perp){
		type.addContent(event);
		type.addContent(reward);
		type.addContent(pre);
		type.addContent(Branch.addContent(branch));
		type.addContent(Perpetual.addContent(perp.toString()));
		return type;
		
	}
	
	public Element buildEvent(LinkedList<Element> pre, String branch, Boolean perp, String chapter, String dialog){
		type.addContent(event);
		type.addContent(reward);
		type.addContent(pre);
		type.addContent(Branch.addContent(branch));
		type.addContent(Perpetual.addContent(perp.toString()));
		type.addContent(Story_Chapter.addContent(chapter));
		type.addContent(Story_Dialog.addContent(dialog));
		return type;
	}
	
	public void buildStoryTrigger(){
		this.event = new StoryTrigger().buildEvent();
	}
	
	public void buildStoryFlag(String name, int value, String cType){
		this.event = new StoryFlag(new Flag(name,value), cType).buildEvent();
	}
	
	public void buildStoryConquer(String planet, String filter){
		this.event = new StoryConquer(planet, filter).buildEvent();
	}
	
	public void buildStoryConstruct(String object, Integer amount, String filter){
		this.event = new StoryConstruct(object,amount,filter).buildEvent();		
	}
	
	public void buildStoryDestroy(String object, String planet, Integer amount, String destroyer){
		this.event = new StoryDestroy(object,planet,amount,destroyer).buildEvent();
	}
	
	public void buildSetFlag(Flag flag, int value){
		this.reward = new SetFlag(flag,value).buildReward();
	}
	
	public void buildBuildable(boolean b, String object){
		this.reward = new Buildable(b,object).buildReward();
	}
	
	public void buildIncFlag(Flag f, Integer inc){
		this.reward = new IncrementFlag (f,inc).buildReward();
	}
	
	public void buildDisableEvent(Event e, boolean b){
		this.reward = new DisableEvent (e.getName(),b).buildReward();
	}
	
	public void buildSpawnUnit(String unit, String planet){
		this.reward = new SpawnUnit (unit,planet).buildReward();
	}
	
	public void buildMovie(String movie){
		this.reward = new Movie(movie).buildReward();
	}
	
	public void buildDisableBranch(String name, boolean disable){
		this.reward = new DisableBranch(name,disable).buildReward();
	}
	
	public void buildLockUnit(String name){
		this.reward = new LockUnit(name).buildReward();
	}
	public String getName(){
		return type.getAttributeValue("Name");
	}
	
	public void setName(String name){
		type.setAttribute("Name", name);
	}
	
//	private String computeBool(boolean b){
//		if(b){
//			return "1";
//		}
//		return "0";
//	}
	
	
}
