package gui;



import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

import eventGui.MovieEventPanel;
import eventGui.SectorControlEventPanel;

import TradeGui.CreateTraderoutesPanel;
import TradeGui.DeleteTraderoutesPanel;
import balancingGui.LoadingPanel;
import balancingGui.OptionsPanel;







public class Gui {

	public static final String TITLE = "Editor";
	private JFrame frame = null;
	private JPanel currentPanel;
	private JMenuBar mbar;
	private JMenu balEd;
	private JMenu chainEvents;
	private JMenuItem filters;
	private JMenuItem balancing;
	private JMenuItem createSectorControlEvent;
	private JMenuItem createMovieEvent;
	private JMenu traderoutes;
	private JMenuItem createTraderoutes;
	private JMenuItem deleteTraderoutes;
	/**
	 * @param args
	 */
	
	public Gui(){
		createMainFrame();	
	}
	
	
	
	private void createMainFrame(){
		frame = new JFrame(TITLE);
		frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		currentPanel = new LoadingPanel(frame);
		frame.add(currentPanel);
		if(mbar == null) createMenuBar();
		frame.setJMenuBar(mbar);
		frame.pack();
		frame.setVisible(true);	
	}
	private void createMenuBar() {
		mbar = new JMenuBar();
//		options = new JMenu("Optionen");
		balEd = new JMenu("Balancing");
		balancing = new JMenuItem (LoadingPanel.LOADFILES);
		balancing.addActionListener(new CreateBalanceListener());
		balEd.add(balancing);
		filters = new JMenuItem (LoadingPanel.CHOOSEFILTER);
		filters.addActionListener(new FilterOptionsListener());
		balEd.add(filters);
		chainEvents = new JMenu(LoadingPanel.CHAINEVENTS);
		createSectorControlEvent = new JMenuItem (LoadingPanel.CREATESECTORCONTROL);
		createSectorControlEvent.addActionListener(new CreateSectorListener());
		createMovieEvent = new JMenuItem (LoadingPanel.CREATEMOVIEEVENT);
		createMovieEvent.addActionListener(new CreateMovieListener());
		chainEvents.add(createSectorControlEvent);
		chainEvents.add(createMovieEvent);
		traderoutes = new JMenu("Traderoutes");
		createTraderoutes = new JMenuItem (LoadingPanel.CREATETRADEROUTE);
		deleteTraderoutes = new JMenuItem (LoadingPanel.DELETETRADEROUTE);
		createTraderoutes.addActionListener(new CreateTradeListener());
		deleteTraderoutes.addActionListener(new DeleteTradeListener());
		traderoutes.add(createTraderoutes);
		traderoutes.add(deleteTraderoutes);
		mbar.add(traderoutes);
		mbar.add(balEd);
//		mbar.add(options);
		mbar.add(chainEvents);
	}
	
	private class CreateTradeListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if(currentPanel!=null)frame.remove(currentPanel);
			currentPanel = new CreateTraderoutesPanel();
			frame.add(currentPanel);
			frame.pack();
			frame.setVisible(true);
		}	
	}
	
	private class DeleteTradeListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if(currentPanel!=null)frame.remove(currentPanel);
			currentPanel = new DeleteTraderoutesPanel();			
			frame.add(currentPanel);
			frame.pack();
			frame.setVisible(true);
		}	
	}
	
	private class CreateSectorListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if(currentPanel!=null)frame.remove(currentPanel);
			currentPanel = new SectorControlEventPanel();			
			frame.add(currentPanel);
			frame.pack();
			frame.setVisible(true);
		}	
	}
	
	private class CreateMovieListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			String[] s = {"Conquer","Construct","Destroy"};
			if(currentPanel!=null)frame.remove(currentPanel);
			currentPanel = new MovieEventPanel(s);			
			frame.add(currentPanel);
			frame.pack();
			frame.setVisible(true);
		}
	}
	
	
	
	private class FilterOptionsListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			if(currentPanel!=null)frame.remove(currentPanel);
			currentPanel = new OptionsPanel();			
			frame.add(currentPanel);
			frame.pack();
			frame.setVisible(true);
		}	
			
	}

	private class CreateBalanceListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if(currentPanel!=null)frame.remove(currentPanel);
			currentPanel = new LoadingPanel(frame);
			frame.add(currentPanel);
			frame.pack();
			frame.setVisible(true);
		}	
	}

	

	
//	private void createFrame(JPanel panel) {
//		frameLocation = frame.getLocation();
//		frame.setVisible(false);		
//		frame = new JFrame(TITLE);
//		frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
//		frame.add(panel, BorderLayout.CENTER);
//		if(mbar == null) createMenuBar();
//		frame.setJMenuBar(mbar);
//		frame.setLocation(frameLocation);
//		frame.pack();
//		frame.setVisible(true);
//	}
	
	
	
	
	
	
}
