package misc;

import java.util.LinkedList;
import java.util.List;


import org.jdom.Element;

import exceptions.NoSuchElementException;

public class ListXml {
	
	private Element root;
	private List<Element> elements;
	private LinkedList<String> elementNames;
	public  ProcessXML px;
	public String file;
	
	@SuppressWarnings("unchecked")
	public ListXml(String file){
		px = new ProcessXML(file);
		root = px.getRoot();
		elements = px.getElements();
		elementNames = new LinkedList<String>();
		this.file = file;
		
		for (Element e : elements){
			try {
				String temp =(e.getAttributeValue("Name"));
				if	(
						(temp.contains("Death")&&!temp.contains("Death_Star"))
						||
						temp.contains("E3")
						||
						temp.contains("Tractor")
						||
						(!temp.contains("IPV1")&&temp.contains("IPV"))
						||
						temp.contains("Easy")
						||
						temp.contains("Ability")
						||
//						(temp.contains("Empire")&& !temp.contains("Star_Base")&& !temp.contains("Tie_Fighter")&&!file.equalsIgnoreCase("factions.xml"))
//						||
//						(temp.contains("Underworld")&& !temp.contains("Star_Base")&&!file.equalsIgnoreCase("factions.xml"))
//						||
//						(temp.contains("Rebel")&& !temp.contains("Star_Base")&&!file.equalsIgnoreCase("factions.xml"))
//						||
//						(temp.contains("Pirates")&& !temp.contains("Star_Base")&&!file.equalsIgnoreCase("factions.xml"))
//						||
						temp.contains("Leader")
						||
						temp.contains("Captain")
						||
						temp.contains("Broadside")
						||
						temp.contains("_E")
						||
						temp.contains("_R")
						||
						temp.contains("_P")
						||
						temp.contains("Fighters")
						||
						temp.contains("Landing")
						||
						temp.contains("Space") 
						||
						temp.contains("Ground")
						||
						temp.contains("Backwards")
						||
						temp.contains("Captured")
						||
						temp.contains("Clone")
						||
						temp.contains("bla")
					)
				{
					continue;
				}
				else{
					elementNames.add(trim(e.getAttributeValue("Name")));				
				}
			} catch (RuntimeException e1) {
			}
		}
		
	}
	
	
	
	public static String trim(String s){
		s=s.replaceAll("\n", "");
		s=s.replaceAll("\t", "");
		s=s.replaceAll(" ", "");
		s=s.trim();
//		System.out.println(s);
		return s;
	}
	
	public static Element getFirstElementInFile(Iterable<Element> i){
		return i.iterator().next();
	}
	
	public static Element findSpecificElementWithName(String name, Iterable<Element> i) throws NoSuchElementException{
		
		for(Element e : i){
			if(e.getAttributeValue("Name").equalsIgnoreCase(trim(name)))
				return e;
		}
		throw new NoSuchElementException(name);
	}
	
	public static Element findSpecificElementWithAttribute(String attr,String name, Iterable<Element> i) throws NoSuchElementException{
		
		for(Element e : i){
			if(e.getAttributeValue(attr).equalsIgnoreCase(trim(name)))
				return e;
		}
		throw new NoSuchElementException();
	}
	
	public static LinkedList<Element> findAllElementsWithName(String name, Iterable<Element> i)throws NoSuchElementException{
		LinkedList<Element> temp = new LinkedList<Element>();
		for (Element e : i){
			if(e.getAttributeValue("Name").equals(trim(name)))
				temp.add(e);
		}
		if (temp.size()==0){
			throw new NoSuchElementException();			
		}
		return temp;
	}
	
	public static LinkedList<Element> findAllElementsBeginningWith(String begin, Iterable<Element> i){
		LinkedList<Element> temp = new LinkedList<Element>();
		for (Element e : i){
			if(e.getAttributeValue("Name").startsWith(begin))
				temp.add(e);
		}
		return temp;
	}
	
	public static Element findSpecificElement(String name, Iterable<Element> i)throws NoSuchElementException{
		for (Element e : i){
//			System.out.println(name);
			if(e.getName().equalsIgnoreCase(trim(name)))
				return e;
		}
		throw new NoSuchElementException();
	}
	
	@SuppressWarnings("unchecked")
	public static LinkedList<Element> findAllElements(String name, Element e)throws NoSuchElementException{
		LinkedList<Element> temp = new LinkedList<Element>();
//		for (Element e : i){
			String trim = trim(name);
			List children = e.getChildren(trim);
			temp.addAll(children);
//		}
		if (temp.size()==0){
			throw new NoSuchElementException();			
		}
		return temp;
	}
	

	public Element getRoot() {
		return root;
	}

	public LinkedList<String> getElementNames() {
		return elementNames;
	}

	public List<Element> getElements() {
		return elements;
	}
	
	public String getFile(){
		return this.file;
	}
	
	public static String[] trimArray(Object[] source){
		String[] temp = new String[source.length];
		for(int i =0 ; i<source.length;i++){
			temp[i] = trim(source[i].toString());
		}		
		return temp;		
	}

}
