package misc;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import balancingGui.LoadingPanel;


public class Message {
	
	private boolean answerQuestion;
	private JDialog d;

	public static void showErrorMessage(Exception e, String title, String txt, boolean critical) {
		JOptionPane.showMessageDialog(new JFrame(), txt + "\n\n" + e.getMessage() + "\n\n" + e.getStackTrace(), title, JOptionPane.ERROR_MESSAGE);
		if(critical){
			showMessage(null,LoadingPanel.CRITICALERROR);

			try {
				File file = new File("Errorlog.txt");
				PrintStream printStream = new PrintStream(file);
				e.printStackTrace(printStream);
				e.printStackTrace();
			} catch (FileNotFoundException e1) {
			}
			System.exit(-1);
		}
	}
	
	public static void showMessage(String title, String txt) {
		JOptionPane.showMessageDialog(new JFrame(), txt, title, JOptionPane.ERROR_MESSAGE);
	}
	
	public boolean safetyQuestion(String question) {
		d = new JDialog();
		d.setModal(true);
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		JPanel subPanel = new JPanel();
		JLabel lbQuestion = new JLabel(question);
		JButton btBack = new JButton("Zurueck");
		btBack.addActionListener(new BtBackActionListener());
		JButton btSave = new JButton("Weiter");
		btSave.addActionListener(new BtSaveActionListener());
		subPanel.add(btSave);
		subPanel.add(btBack);
		panel.add(lbQuestion, BorderLayout.NORTH);
		panel.add(subPanel);
		d.add(panel);
		d.pack();
		d.setVisible(true);
		return answerQuestion;
	}
		
	private class BtBackActionListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			answerQuestion = false;
			d.setVisible(false);
			d.setEnabled(false);
		}
	}
	
	private class BtSaveActionListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			answerQuestion = true;
			d.setVisible(false);
			d.setEnabled(false);
		}
	}
}
