package misc;

import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

import balancingGui.LoadingPanel;

public class ProcessXML {
	
	private Document source;
	private Element root;
	private LinkedList<Element> elements;
	private static Document hardpoints = null;

	@SuppressWarnings("unchecked")
	public ProcessXML(String file){
		elements = new LinkedList<Element>();
		SAXBuilder builder = new SAXBuilder();
		boolean b = (file.equals("Hardpoints.xml"));
		boolean c = (hardpoints == null);
		if (!b || c) {
			try {
				try {
					source = builder.build(file);
				} catch (org.jdom.IllegalDataException e) {
					Message.showErrorMessage(e, LoadingPanel.READERROR, LoadingPanel.INCORRECTFILE+file+"\n"+LoadingPanel.FIXERRORANDRESTART,true);
				}
			} catch (JDOMException e) {
//				if(e.getClass() == (org.jdom.IllegalDataException)
//				e.printStackTrace();
				Message.showErrorMessage(e, LoadingPanel.READERROR,
						LoadingPanel.INVALIDFILE + file + '\n'
								+ LoadingPanel.EDITORSHUTDOWN,true);
			} catch (IOException e) {
				if (e.getClass() == (com.sun.org.apache.xerces.internal.impl.io.MalformedByteSequenceException.class)){
					Message.showErrorMessage(e, LoadingPanel.READERROR,
							LoadingPanel.INVALIDFILE + file + '\n'
									+ LoadingPanel.DELETESPECIALCHARS + "\n" + LoadingPanel.MAILTO+"\n"+"benjamin_erbert@hotmail.com",true);
				}
// if ( e.getClass() == (org.jdom.IllegalDataException))
// Message.showErrorMessage(e, "", txt)
				else {
					Message.showErrorMessage(e, LoadingPanel.FILENOTFOUND,
							LoadingPanel.EDITORSHUTDOWN,true);
				}
			}
		} else {
			source = hardpoints;
		}
		if(b&&c){
			hardpoints = source;
		}
		this.root = source.getRootElement();
		this.elements.addAll(root.getChildren());
	}
	
	public Element getRoot(){
		return root;
	}
	
	public LinkedList<Element> getElements(){
		return elements;
	}
	
	public static void writeXML(Element root, String file){
		Document output = root.getDocument();
		XMLOutputter out = new XMLOutputter(Format.getPrettyFormat() );
		try {
			out.output(output, new FileWriter(file));
		} catch (IOException f) {
			f.printStackTrace();
		}
	}
	


}
