package newEntityPanels;

import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.util.LinkedList;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import balancingGui.LoadingPanel;
import entities.*;

public class EntityPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3319444353052734988L;
	
	protected Entities ens;
	protected Entity current;
	protected LinkedList<JLabel> labels ;
	protected LinkedList<JComponent> components;
	protected LinkedList<JButton> buttons;
	protected JLabel lbName = new JLabel("Name");
	protected EntityPanel currentPanel;
	protected String file;
	protected JFrame mainFrame;
	
	// Layout
	protected static GridBagLayout gbl = new GridBagLayout();
	protected static int gridx=0,gridy = 0;
	protected  boolean isHardpoint 	;
	protected  boolean isProjectile	;
	protected  boolean isSpaceUnit			;	
	protected  boolean isGroundUnit			;	
	protected  boolean isHeroUnit			;	
	protected  boolean isAbility		;	
	protected  boolean isCustom		;	
	
	public boolean isNew;
	
	
	public EntityPanel (String file, JFrame mainFrame){
		this.mainFrame = mainFrame;
		labels = new LinkedList<JLabel>();
		components = new LinkedList<JComponent>();
		buttons = new LinkedList<JButton>();
		this.setLayout(gbl);
		isHardpoint 	= file.equals("Hardpoints.xml")||file.equals("HpPrototypes.xml");
		isProjectile	= file.equals("Projectiles.xml");
		isAbility		= file.equals("UnitAbilitys.xml");
		for(String s : LoadingPanel.spaceFiles)
			if(s.equals(file))
				isSpaceUnit		= true;
		for(String s : LoadingPanel.groundFiles)
			if(s.equals(file))
				isGroundUnit	= true;	
		for(String s : LoadingPanel.heroFiles)
			if(s.equals(file))
				isHeroUnit		= true;	
		if(!isHardpoint&&!isAbility&&!isGroundUnit&&!isHeroUnit&&!isProjectile&&!isSpaceUnit){
			isCustom=true;
		}
		labels.add(lbName);
		gridx = 0;
		gridy = 0;
		if(file!=null)
			this.file=file;
		
	}
	
	public String getCorrespondingName(JComponent comp){
		return labels.get(components.indexOf(comp)).getText();
	}
	
	
	
	public int getPosition(String label){
		for(int i=0;i<this.labels.size();i++){
			String text = this.labels.get(i).getText();
			if(label.equalsIgnoreCase(text)){
				return i;
			}
		}
		return -1;
	}
	
	public boolean contains(String name){
		for(int i=0;i<labels.size();i++){
			String text = labels.get(i).getText();
			if(name.equalsIgnoreCase(text)){
				return true;
			}
		}
		return false;
	}
	

	public static void addComponent(Container cont, GridBagLayout gbl, Component c,
			int x, int y, int width, int height, double weightx, double weighty) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.weightx = weightx;
		gbc.weighty = weighty;
		gbl.setConstraints(c, gbc);
		cont.add(c);
	}
	
	public static void addComponent(Container cont, Component c,
			int gridx, int gridy) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridx = gridx;
		gbc.gridy = gridy;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbl.setConstraints(c, gbc);
		cont.add(c);
	}


	public Entities getEntities() {
		return ens;
	}
	

	public String toString(){
		return "EntityPanel"+":"+file+":"+this.current+":"+EntityPanel.gridx+":"+EntityPanel.gridy;
	}
	

}
