package newEntityPanels;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.DefaultListModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;

import misc.ListXml;

import org.jdom.Element;

import xmlFilter.XmlFilter;

import balancingGui.EntityFrame;
import balancingGui.LoadingPanel;
import entities.Entities;
import entities.Entity;
import entities.Hardpoint;
import exceptions.ElementNotFoundException;

public class SingleEntityPanel extends EntityPanel {
	
	
	private Color backc = Color.ORANGE;
	private String[] labelFilter = initFilter(file);
	private EntityFrame subFrame = null;
	private Entity topEnt = null;
	private EntityPanel rootPanel = null;
	private LinkedList<JButton> buttons2 = new LinkedList<JButton>();
	/**
	 * 
	 */
	private static final long serialVersionUID = 3593415613783462872L;
	
	private JComboBox entityDropDown;
	private JButton btSave;
	private JButton btCreate;
	private LinkedList<Entity> subEnt;
	public Entity type;
	
	public SingleEntityPanel(String file,JFrame mainFrame,Entity e, LinkedList<Entity> subEnt, EntityPanel rootPanel2){
		super(file,mainFrame);
		this.subEnt = subEnt;
		
		
		this.ens = initEntities(file);
		this.current = ens.getFirst();
			try {
				this.topEnt = e;
			} catch (RuntimeException e1) {
			}
		
		for(int i=1;i<labels.size()-1;i++){
			this.remove(labels.get(i));
			labels.remove(i);
		}
		
		initLabels();
		addLabels();
		
		initEntity();
		if(rootPanel2!=null)
			this.rootPanel = rootPanel2;
		else
			this.rootPanel = this;
		
	}
	
	private void initEntity(){
		gridx=0;
		gridy=0;
		for(int i=1;i<components.size()-1;i++){
			this.remove(components.get(i));
			components.remove(i);
		}
		entityDropDown = new JComboBox(ens.toArray());
		entityDropDown.addActionListener(new SelectEntityListener());
		entityDropDown.setName("Name");
		components.add(entityDropDown);
		current = (Entity) entityDropDown.getSelectedItem();
		for(String s : labelFilter){
			JTextField textField = null;
			try {
				textField = new JTextField(current.getAttribute(s).getFirst().getText(), current.getAttribute(s).getFirst().getText().split(",").length);
			} catch (ElementNotFoundException e) {
				textField = new JTextField("", 30);
			}
			textField.setHorizontalAlignment(JTextField.LEFT);
			textField.setName(s);
			components.add(textField);
		}
		
		createSpecialCases();
		fillComponents();
		
		addComponents();
		
		for(int i=1;i<buttons.size()-1;i++){
			this.remove(buttons.get(i));
			buttons.remove(i);
		}
		initButtons();
		addButtons();
		this.validate();
	}
	
	private LinkedList<String> getContent() {
//		Iterator<Element> modIt = null;
		Iterator<Element> fireIt = null;
		try {
			fireIt = current.getAttribute("Fire_Inaccuracy_Distance").iterator();
//			modIt = current.getAttribute("Mod_Multiplier").iterator();
		} catch (ElementNotFoundException e1) {
			
		}
		LinkedList<String> temp  = new LinkedList<String>();
		for(JComponent jc : components){
			if(jc instanceof JTextField){
				JTextField jtf = (JTextField) jc;
				String text;
				String name2 = jc.getName();
//				boolean modMulti = jtf.getName().equals("Mod_Multiplier")||modIt==null;
				boolean fireMulti = jtf.getName().equals("Fire_Inaccuracy_Distance")&&fireIt!=null;
				if(!fireMulti){
					text = jtf.getText();
					current.setAttribute(name2,text,null);
					continue;
				}
				else{
					if(fireMulti){
						text = jtf.getText();
						Element next = null;
						try {
							next = fireIt.next();
							current.setAttribute(name2, text, next);
						} catch (RuntimeException e) {
						}

						continue;
					}
//					if(modMulti) {
//						text = jtf.getText();
//						Element next = null;
//						try {
//							next = modIt.next();
//						} catch (RuntimeException e) {
//						}
//						if (next != null) {
//							current.setAttribute(name2, text, next);
//						}
//
//						continue;
//					}
					
				}
				
			}
			if (jc instanceof JCheckBox){
				JCheckBox jcb = (JCheckBox) jc;
				String text;
				String name2 = jc.getName();
				String temp2 = null;
				try {
					temp2 = current.getAttribute(name2).getFirst().getText();
					text = encode(jcb.isSelected(),temp2);
					current.setAttribute(name2,text,null);
				} catch (ElementNotFoundException e) {
				}
				continue;
			}
			if (jc instanceof JComboBox) {
				JComboBox jcb = (JComboBox) jc;
				String text;
				String name2 = jc.getName();
				Object selectedItem = jcb.getSelectedItem();

				if (selectedItem != null) {
					text = selectedItem.toString();
					current.setAttribute(name2, text,null);
				}
				continue;
			}
			if (jc instanceof JSpinner){
				JSpinner js = (JSpinner) jc;
				String text;
				String name2 = jc.getName();
				text = js.getValue().toString();
				current.setAttribute(name2,text,null);
				continue;
			}
		}
		return temp;
	}
	
	

	
	
	private void fillComponents(){
//		Iterator<Element> modIt = null;
		Iterator<Element> fireIt = null;
		try {
			fireIt = current.getAttribute("Fire_Inaccuracy_Distance").iterator();
		} catch (ElementNotFoundException e1) {
			
		}
		for(JComponent jc : components){
			
			if(jc instanceof JTextField){
				JTextField jtf = (JTextField) jc;
				String text;
				boolean fireMulti = jtf.getName().equals("Fire_Inaccuracy_Distance")&&(fireIt!=null);
				if(!fireMulti){
					if(jtf.getName().equalsIgnoreCase("Squadron_Units")){
						jtf.setBackground(backc);
						jtf.setDisabledTextColor(Color.BLUE);
						jtf.setText(current.getSqUnits());
						jtf.setEditable(false);
						continue;
					}
					try {
						String name2 = jc.getName();
						text = current.getAttribute(name2).getFirst().getText();
						jtf.setBackground(backc);
						jtf.setDisabledTextColor(Color.BLUE);
					} catch (ElementNotFoundException e) {
						text = "";
						jtf.setBackground(Color.WHITE);
					}
					jtf.setText(text);
					continue;
				}
				else{
					if(fireMulti){
						jtf.setBackground(backc);
						jtf.setDisabledTextColor(Color.BLUE);
						String trim = null;
						try {
							Element next = fireIt.next();
							trim = ListXml.trim(next.getText());
						} catch (RuntimeException e) {
							trim = "";
							jtf.setBackground(Color.WHITE);
						}
						jtf.setText(trim);
					}
				}
				
			}
			if (jc instanceof JCheckBox){
				JCheckBox jcb = (JCheckBox) jc;
				String text;
				try {
					text = current.getAttribute(jc.getName()).getFirst().getText();
					jcb.setBackground(backc);
				} catch (ElementNotFoundException e) {
					text = "";
					jcb.setBackground(Color.WHITE);
				}
				jcb.setSelected(decode(text));
				continue;
			}
			if (jc instanceof JComboBox) {
				JComboBox jcb = (JComboBox) jc;
				String text;
				try {
					String correspondingName = jc.getName();
					if(correspondingName.equals("Projectile_Types_Override")){
						System.out.println();
					}
					if(!correspondingName.equalsIgnoreCase("name"))
						text = ListXml.trim(current.getAttribute(jc.getName()).getFirst().getText());
					else
						text = current.toString();
					jcb.setBackground(backc);
				} catch (ElementNotFoundException e) {
					text = "";
					jcb.setBackground(Color.WHITE);
				}
				if(!text.equalsIgnoreCase("")){
					jcb.setSelectedItem(text);
				}
				else
					jcb.setSelectedItem(null);
				
				continue;
			}
			if (jc instanceof JSpinner){
				JSpinner js = (JSpinner) jc;
				String text;
				try {
					text = current.getAttribute(jc.getName()).getFirst().getText();
					js.setBackground(backc);
				} catch (ElementNotFoundException e) {
					text = "";
					js.setBackground(Color.WHITE);
				}
				if(!text.equals(""))
					try {
						js.setValue(Integer.parseInt(text));
					} catch (NumberFormatException e) {
						js.setValue(Double.parseDouble(text));
					}
				else
					js.setValue(1);
				continue;
			}
		}
	}
	
	private boolean decode(String text) {
		if(text.equalsIgnoreCase("Yes")||text.equalsIgnoreCase("True")||text.equalsIgnoreCase("1"))
			return true;
		else
			return false;
	}
	
	private String encode(boolean b, String text) {
		if((text.equalsIgnoreCase("Yes")||text.equalsIgnoreCase("No"))&&b)
			return "Yes";
		if((text.equalsIgnoreCase("Yes")||text.equalsIgnoreCase("No"))&&!b)
			return "No";
		if((text.equalsIgnoreCase("True")||text.equalsIgnoreCase("False"))&&b)
			return "True";
		if((text.equalsIgnoreCase("True")||text.equalsIgnoreCase("False"))&&!b)
			return "False";
		if((text.equalsIgnoreCase("1")||text.equalsIgnoreCase("0"))&&b)
			return "1";
		if((text.equalsIgnoreCase("1")||text.equalsIgnoreCase("0"))&&!b)
			return "0";
		return null;		
	}

	private void createSpecialCases(){
		String s;
		/*----------------------------------Projectiles -------------------------------------*/
		
		
		//Spinner
		s="Projectile_Custom_Render";
		spinnerField(s, 0, 0, 2, 1, LoadingPanel.OWNRENDER);
		s="Projectile_Width";
		spinnerField(s, 0.1, 0.1, 10.0, 0.1, LoadingPanel.OWNRENDER);
		
		//ChooseBox
		s="Projectile_Category";
		choiceBox(s,LoadingPanel.projCat);
		
		//checkBoxes
		s="Does_Shield_Damage";
		checkBox(s,LoadingPanel.YES);
		s="Hitpoint_Damage";
		checkBox(s,LoadingPanel.YES);
		s="Projectile_Ion_Stun_On_Detonation";
		checkBox(s,LoadingPanel.YES);
		s="Projectile_Stun_On_Detonation";
		checkBox(s,LoadingPanel.YES);
		s="Projectile_Disables_Engines_When_Power_Drained";
		checkBox(s,LoadingPanel.YES);
		s="Explode_When_Reached_Target_Radius";
		checkBox(s,LoadingPanel.YES);
		s="Projectile_Instant_Heal_On_Detonation";
		checkBox(s,LoadingPanel.YES);
		s="Projectile_Cause_Invulnerability_On_Detonation";
		checkBox(s,LoadingPanel.YES);
		s="Projectile_Convert_Enemy_On_Detonation";
		checkBox(s,LoadingPanel.YES);
		s="Projectile_Weaken_Enemy_On_Detonation";
		checkBox(s,LoadingPanel.YES);
		
		//noeffectFields
		s="Does_Energy_Damage";
		noEffectTextField(s, LoadingPanel.NOEFFECT);
		
		/*----------------------------------HardPoints -------------------------------------*/

		s="Fire_Projectile_Type";
		fileReferenceBox("Projectiles.xml", s);
		

		s="Is_Targetable";
		checkBox(s,LoadingPanel.YES);
		s="Is_Destroyable";
		checkBox(s,LoadingPanel.YES);
		s="Fire_When_In_Rocket_Attack_Mode";
		checkBox(s,LoadingPanel.YES);
		s="Fire_When_In_Normal_Attack_Mode";
		checkBox(s,LoadingPanel.YES);
		

		s="Type";
		choiceBox(s,LoadingPanel.hpTypes);
		s="Damage_Type";
		choiceBox(s,LoadingPanel.DamageTypes);
		s="Death_Explosion_Particles";
		choiceBox(s,LoadingPanel.explosionParticles);
		s="Death_Explosion_SFXEvent";
		choiceBox(s,LoadingPanel.hpDeathSfx);
		s="Damage_Decal";
		choiceBox(s,LoadingPanel.hpDamageDecal);
		s="Damage_Particles";
		choiceBox(s,LoadingPanel.hpDamageParticle);
		s="Fire_SFXEvent";
		choiceBox(s,LoadingPanel.hpFireSfx);
		
		
		
		/*----------------------------------Space Units-------------------------------------*/
		//fileReferences
		s="required_special_structures";
		fileReferenceBox("SpecialStructures.xml",s);
		s="affiliation";
		fileReferenceBox("Factions.xml",s);	
		
		//checkBoxes
		s="gui_row";
		checkBox(s,LoadingPanel.TOPROW);
		s="Hyperspace";
		checkBox(s,LoadingPanel.YES);
		s="Build_Initially_Locked";
		checkBox(s,LoadingPanel.YES);
		s="Build_Can_Be_Unlocked_By_Slicer";
		checkBox(s,LoadingPanel.YES);
		s="Is_Escort";
		checkBox(s,LoadingPanel.YES);
		s="Is_Bomber";
		checkBox(s,LoadingPanel.YES);
		s="Build_Tab_Space_Units";
		checkBox(s,LoadingPanel.YES);
		s="Build_Tab_Land_Units";
		checkBox(s,LoadingPanel.YES);
		s="Build_Tab_Special_Structures";
		checkBox(s,LoadingPanel.YES);
		s="Build_Tab_Heroes";
		checkBox(s,LoadingPanel.YES);
		s="Collidable_By_Projectile_Living";
		checkBox(s,LoadingPanel.YES);
		s="Has_Space_Evaluator";
		checkBox(s,LoadingPanel.YES);
		s="Victory_Relevant";
		checkBox(s,LoadingPanel.YES);
		s="Space_Full_Stop_Command";
		checkBox(s,LoadingPanel.YES);
		s="Is_Visible_On_Radar";
		checkBox(s,LoadingPanel.YES);
		s="Death_Leave_Hulk_Behind";
		checkBox(s,LoadingPanel.YES);
		
		
		
		
		//choiceBoxes
		s="Space_Layer";
		choiceBox(s,LoadingPanel.spaceLayers);
		s="Armor_Type";
		choiceBox(s,LoadingPanel.ArmorTypes);
		s="Shield_Armor_Type";
		choiceBox(s,LoadingPanel.ArmorTypes);
		s="MovementClass";
		choiceBox(s,LoadingPanel.moveClasses);
		s="Ship_Class";
		choiceBox(s,LoadingPanel.unitClasses);
		s="Death_Explosions";
		choiceBox(s,LoadingPanel.explosionParticles);
		s="Asteroid_Damage_Hit_Particles";
		choiceBox(s,LoadingPanel.hpDamageParticle);
//		s="Hardpoints";
//		choiceBox(s,current.getHardpoints());
		s="Targeting_Priority_Set";
		choiceBox(s,LoadingPanel.targetingPriorities);
		s="Unit_Abilities_Data";
		choiceBox(s,current.getAbilityNames());
		
		//noEffectFields
		s="Energy_Capacity";
		noEffectTextField(s, LoadingPanel.NOEFFECT);
		s="Energy_Refresh_Rate";
		noEffectTextField(s, LoadingPanel.NOEFFECT);		
		s="Maintenance_Cost";
		noEffectTextField(s, LoadingPanel.NOEFFECT);	
		s="Required_Timeline";
		noEffectTextField(s, LoadingPanel.NOEFFECT);
		s="Required_Ground_Base_Level";
		noEffectTextField(s, LoadingPanel.NOEFFECT);
		s="Political_Control";
		noEffectTextField(s, LoadingPanel.NOEFFECT);
		s="Squadron_Capacity";
		noEffectTextField(s, LoadingPanel.NOEFFECT);
		s="Transport_Capacity";
		noEffectTextField(s, LoadingPanel.NOEFFECT);
		
		//spinnerFields
		s="Tech_Level";
		spinnerField(s,0,0,5,1,LoadingPanel.TECHLEVEL);
		s="Required_Star_Base_Level";
		spinnerField(s,1,1,5,1,"1-5");
		s="Population_Value";
		spinnerField(s,0,0,50,1,"0-50");
		

		
		
		//deactivate Type for Ability
		s="Type";
		deactivate(file,s);
		
		//checkBoxes
		s="Disable_Movement";
		checkBox(s,LoadingPanel.YES); 
		s="Is_Pulsing";
		checkBox(s,LoadingPanel.YES); 
		s="Active_By_Default";
		checkBox(s,LoadingPanel.YES);
		
		//fileReference
		s="Projectile_Types_Override";
		fileReferenceBox("Projectiles.xml", s);
		
		
	}
	
	
	
	
	
	private void spinnerField(String s, double d, double e, double f, double g, String string) {
		if(contains(s)&&(components.get(getPosition(s)) instanceof JTextField)){
			SpinnerNumberModel model1 = new SpinnerNumberModel( d,e,f,g ); 
		    JSpinner temp = new JSpinner( model1 ); 
		    temp.setToolTipText(string);
		    temp.setName(s);
			components.set(getPosition(s), temp);
		}
		
	}

	private void deactivate(String file, String s) {
		if(isAbility)
			components.get(getPosition(s)).setEnabled(false);
		
	}

	private void spinnerField(String s, int value, int min, int max, int step , String tool){
		if(contains(s)&&(components.get(getPosition(s)) instanceof JTextField)){
			SpinnerNumberModel model1 = new SpinnerNumberModel( value,min,max,step ); 
		    JSpinner temp = new JSpinner( model1 ); 
		    temp.setToolTipText(tool);
		    temp.setName(s);
			components.set(getPosition(s), temp);
		}
	}
	
	private void checkBox(String s, String text){
		if(contains(s)&&(components.get(getPosition(s)) instanceof JTextField)){
			JCheckBox temp  = new JCheckBox(text);
		    temp.setName(s);
			components.set(getPosition(s), temp);
		}
	}
	
	private void choiceBox(String s , String[] sa){
		if(contains(s)){
			
			
			if (components.get(getPosition(s)) instanceof JTextField) {
				JComboBox temp = new JComboBox(ListXml.trimArray(sa));
				temp.setName(s);
				components.set(getPosition(s), temp);
			} else {
				JComboBox existing = (JComboBox) components.get(getPosition(s));
				existing.removeAllItems();
				for (String s2 : sa) {
					existing.addItem(ListXml.trim(s2));
				}
			}
		}
	}
	
	
	
	private void noEffectTextField(String s, String tooltip){
		if(contains(s)&&(components.get(getPosition(s)) instanceof JTextField)){
			gridy = getPosition(s);
			JTextField component2 = (JTextField)components.get(gridy);
			component2.setEditable(false);
			component2.setToolTipText(tooltip);
		    component2.setName(s);			
		}
	}
	
	private JComboBox fileReferenceBox(String file, String s){
		if(contains(s)&&(components.get(getPosition(s)) instanceof JTextField)){
			Entities temp = new Entities(file);
			JComboBox temp2 = new JComboBox(ListXml.trimArray(temp.getShipNames().toArray()));
			if(file.equalsIgnoreCase("Factions.xml")){
				temp2.addItem("Rebel,Empire,Pirates");
				temp2.addItem("Empire,Pirates");
				temp2.addItem("Rebel,Empire");
				temp2.addItem("Rebel,Pirates");
			}
		    temp2.setName(s);
			components.set(getPosition(s), temp2);
			return temp2;
		}
		return new JComboBox();
	}
	
	
	
	private void addComponents(){
		gridx=1;gridy=0;
		for(JComponent jc : components){
			
			addComponent(this, jc, gridx, gridy++);
		}
		
	}
	
	private void addLabels(){
		gridx=0;gridy=0;
		
		for(JLabel jl : labels){
			addComponent(this,jl, gridx, gridy++);
//			System.out.println("addLabel : "+"LabelSize : "+labels.size()+" : "+"Label : "+jl.getText()+" : ");
		}
		this.validate();
	}
	
	private void addButtons(){
		gridx = 2;
		btSave = new JButton(LoadingPanel.BTSAVE);
		btSave.addActionListener(new BtSaveListener());
		btSave.setIcon(new ImageIcon("icons/save.png"));
		addComponent(this, btSave, 2, 0);
		btCreate = new JButton(LoadingPanel.BTCREATE);
		btCreate.addActionListener(new BtCreateListener());
		btCreate.setIcon(new ImageIcon("icons/new.png"));
		if((isSpaceUnit||isGroundUnit||isHeroUnit)){
			addComponent(this, btCreate, 3, 0);			
		}
		for(JButton jb : buttons){
			int position = getPosition(jb.getName());
			if(position!=-1)
			addComponent(this,jb, gridx, position);
		}
		gridx =3;
		for(JButton jb : buttons2){
			int position = getPosition(jb.getName());
			if(position!=-1)
			addComponent(this,jb, gridx, position);
		}
	}
	
	private void initButtons(){
		gridx=2;
		String s;
		s="Shield_Normal_Color";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.CHOOSECOLOR);
			temp.addActionListener(new BtColorActionListener(s));
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}	
		s="Shield_Upgraded_Color";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.CHOOSECOLOR);
			temp.addActionListener(new BtColorActionListener(s));
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}	
		s="No_Colorization_Color";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.CHOOSECOLOR);
			temp.addActionListener(new BtColorActionListener(s));
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}	
		s="Projectile_Laser_Color";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.CHOOSECOLOR);
			temp.addActionListener(new BtColorActionListener(s));
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}	
		s = "text_id";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.SUGGESTNAME);
			temp.addActionListener(new BtSuggestActionListener());
			gridy = getPosition(s);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}	
		s="Damage";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.GENERATE);
			temp.addActionListener(new BtAutoDamageListener());
			gridy = getPosition(s);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}
		s="Autoresolve_Health";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.GENERATE);
			temp.addActionListener(new BtAutoHealthListener());
			gridy = getPosition(s);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}
		s="Tactical_Health";
		if(contains(s)&&current.hasHP){
			JButton temp=new JButton(LoadingPanel.GENERATE);
			temp.addActionListener(new BtCalcHealthListener());
			gridy = getPosition(s);
			JTextField component2 = (JTextField)components.get(gridy);
			component2.setEditable(false);
			component2.setToolTipText(LoadingPanel.TACHEALTHGEN);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}
		s="Ai_Combat_Power";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.GENERATE);
			temp.addActionListener(new BtCalcCombatPowerListener());
			gridy = getPosition(s);
			JTextField component2 = (JTextField)components.get(gridy);
			component2.setEditable(false);
			component2.setToolTipText(LoadingPanel.AIAUTOGEN);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}
		s="Required_Planets";
		if(contains(s)&&current.hasHP){
			JButton temp=new JButton(LoadingPanel.SETPLANET);
			temp.addActionListener(new BtPlanetListener());
			gridy = getPosition(s);
			JTextField component2 = (JTextField)components.get(gridy);
			component2.setEditable(false);
			component2.setToolTipText(LoadingPanel.ISSETBYSETPLANET);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}
		s="Behavior";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.SETBEHAVIOR);
			temp.addActionListener(new BtBehaviorListener(LoadingPanel.behaviors,s));
			gridy = getPosition(s);
			JTextField component2 = (JTextField)components.get(gridy);
			component2.setEditable(false);
			component2.setToolTipText(LoadingPanel.ISSETBYSETBEHAVIOR);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}
		s="SpaceBehavior";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.SETBEHAVIOR);
			temp.addActionListener(new BtBehaviorListener(LoadingPanel.spacebehaviors,s));
			gridy = getPosition(s);
			JTextField component2 = (JTextField)components.get(gridy);
			component2.setEditable(false);
			component2.setToolTipText(LoadingPanel.ISSETBYSETBEHAVIOR);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}
		s="LandBehavior";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.SETBEHAVIOR);
			temp.addActionListener(new BtBehaviorListener(LoadingPanel.landbehaviors,s));
			gridy = getPosition(s);
			JTextField component2 = (JTextField)components.get(gridy);
			component2.setEditable(false);
			component2.setToolTipText(LoadingPanel.ISSETBYSETBEHAVIOR);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}
		s="CategoryMask";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.SETCATEGORYMASK);
			temp.addActionListener(new BtCategoryListener());
			gridy = getPosition(s);
			JTextField component2 = (JTextField)components.get(gridy);
			component2.setEditable(false);
			component2.setToolTipText(LoadingPanel.ISSETBYSETCATEGORYMASK);
		    temp.setName(s);
			buttons.add(temp);
//			addComponent(this, temp, gridx, gridy);
		}
		s="Hardpoints";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.BTADD);
			JButton temp2=new JButton(LoadingPanel.BTEDIT);
			temp.addActionListener(new BtCreateHardpointListener());
			temp2.addActionListener(new BtEditHardpointListener());
		    temp.setIcon(new ImageIcon("icons/add.png"));
		    temp2.setIcon(new ImageIcon("icons/edit.png"));
		    temp.setName(s);
		    temp2.setName(s);
			buttons.add(temp);
			buttons2.add(temp2);
//			addComponent(this, temp, gridx, gridy);
		}

		s="Fire_Projectile_Type";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.BTADD);
			JButton temp2=new JButton(LoadingPanel.BTEDIT);
			temp.addActionListener(new BtCreateProjListener());
			temp2.addActionListener(new BtEditProjListener());
		    temp.setIcon(new ImageIcon("icons/add.png"));
		    temp2.setIcon(new ImageIcon("icons/edit.png"));
		    temp.setName(s);
		    temp2.setName(s);
			buttons.add(temp);
			buttons2.add(temp2);
//			addComponent(this, temp, gridx, gridy);
		}
		s="Unit_Abilities_Data";
		if(contains(s)){
			JButton temp=new JButton(LoadingPanel.BTADD);
			JButton temp2=new JButton(LoadingPanel.BTEDIT);
			temp.addActionListener(new BtCreateUnitAbilityListener());
			temp2.addActionListener(new BtEditUnitAbilityListener());
		    temp.setIcon(new ImageIcon("icons/add.png"));
		    temp2.setIcon(new ImageIcon("icons/edit.png"));
		    temp.setName(s);
		    temp2.setName(s);
			buttons.add(temp);
			buttons2.add(temp2);
//			addComponent(this, temp, gridx, gridy);
		}
	}
	
	private Entities initEntities(String file){
		Entities temp = null ;
		try {
			temp = Entities.toEntities(subEnt);
		} catch (RuntimeException e) {
			if(isHardpoint){
				temp = new Entities(file,LoadingPanel.Filters.get(4).getFilter(),LoadingPanel.Filters.get(3).getFilter());
			}
			if(isProjectile){
				temp =  new Entities(file,null,LoadingPanel.Filters.get(4).getFilter());			
			}
			if(isSpaceUnit){
				temp = new Entities(file,LoadingPanel.Filters.get(3).getFilter(),LoadingPanel.Filters.get(0).getFilter());
			}
			if(isGroundUnit){
				temp = new Entities(file,LoadingPanel.Filters.get(3).getFilter(),LoadingPanel.Filters.get(1).getFilter());
			}
			if(isHeroUnit){
				temp = new Entities(file,LoadingPanel.Filters.get(3).getFilter(),LoadingPanel.Filters.get(2).getFilter());
			}
			if(isCustom){
				XmlFilter hpfilter = (XmlFilter) JOptionPane.showInputDialog( null, 
			              "HardpointFilter", 
			              LoadingPanel.SELECTFILTER, 
			              JOptionPane.QUESTION_MESSAGE, 
			              null, LoadingPanel.Filters.toArray(), 
			              LoadingPanel.filterFiles.get(0) ); 
				XmlFilter unitfilter = (XmlFilter) JOptionPane.showInputDialog( null, 
							LoadingPanel.UNITFILTER, 
							LoadingPanel.SELECTFILTER, 
			              JOptionPane.QUESTION_MESSAGE, 
			              null, LoadingPanel.Filters.toArray(), 
			              LoadingPanel.filterFiles.get(0) ); 
				temp = new Entities(file,hpfilter.getFilter(),unitfilter.getFilter());
			}
		}		
		return temp;
	}

	private void initLabels(){
//		for(Element e : current.getRealAttributes()){
//			labels.add(new JLabel(e.getName()));
//		}
		
		for(String s : labelFilter){
			labels.add(new JLabel(s));
		}
	}
	
	
	
	
	
	private String[] initFilter(String file){
		if(isHardpoint){
			return LoadingPanel.Filters.get(3).getFilter();
		}
		if(isProjectile){
			return LoadingPanel.Filters.get(4).getFilter();			
		}
		if(isSpaceUnit){
			return LoadingPanel.Filters.get(0).getFilter();
		}
		if(isGroundUnit){
			return LoadingPanel.Filters.get(1).getFilter();
		}
		if(isHeroUnit){
			return LoadingPanel.Filters.get(2).getFilter();
		}
		if(isCustom){
				XmlFilter filter = (XmlFilter) JOptionPane.showInputDialog( null, 
			              "Filter", 
			              LoadingPanel.CHOOSEFILTERBYFILE, 
			              JOptionPane.QUESTION_MESSAGE, 
			              null, LoadingPanel.Filters.toArray(), 
			              LoadingPanel.filterFiles.get(0) ); 
				return filter.getFilter();
		}
		return null;
	}
	
	private class BtColorActionListener implements ActionListener{
		private String name;
		public BtColorActionListener(String s){
			this.name=s;
		}
		
		public void actionPerformed(ActionEvent e) {			
			JTextField component2 = (JTextField) components.get(getPosition(name));
			Integer[] ia = new Integer[4];
			Color nC = JColorChooser.showDialog(null, LoadingPanel.CHOOSECOLOR,current.getColor(name));
			ia[0] = nC.getRed();
			ia[1] = nC.getGreen();
			ia[2] = nC.getBlue();
			ia[3] = nC.getAlpha();
			String s = ia[0]+","+ia[1]+","+ia[2]+","+ia[3];
			component2.setText(s);
			current.setAttribute(name,s ,null);
		}	
	}
	
	private class BtSuggestActionListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			JTextField component2 = (JTextField) components.get(getPosition("Text_Id"));
			component2.setText(LoadingPanel.modName.toUpperCase()+"_"+current.toString().toUpperCase()+"_"+"TXT");
			component2 = (JTextField) components.get(getPosition("Encyclopedia_Text"));
			component2.setText(LoadingPanel.modName.toUpperCase()+"_"+current.toString().toUpperCase()+"_"+"TOOL");
		}	
	}
	
	private class BtAutoDamageListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			JTextField component2 = (JTextField) components.get(getPosition("Damage"));
			Integer autoDamage = 0;
			if(current.hasHP){
				for(Entity h : current.getHardpoints()){
					h = (Hardpoint) h;
					autoDamage = autoDamage + h.getDps();
				}
			}
			else{
				autoDamage = current.getDps();
			}
			if(current.hasHP && current.hasProj ){
				autoDamage = current.getDps();
				for(Entity h : current.getHardpoints()){
					h = (Hardpoint) h;
					autoDamage = autoDamage + h.getDps();
				}
			}
			component2.setText(autoDamage.toString());
		}		
	}
	
	private class BtAutoHealthListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			JTextField component2 = (JTextField) components.get(getPosition("Autoresolve_Health"));
			Integer autoHealth = 0;
			if(current.hasHP){
				for(Entity h : current.getHardpoints()){
					h = (Hardpoint) h;
					autoHealth = autoHealth + h.calcHealth();
				}
			}
			else{
				autoHealth = current.calcHealth();
			}
			component2.setText(autoHealth.toString());
		}		
	}
	
	private class BtCalcHealthListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			JTextField component2 = (JTextField) components.get(getPosition("Tactical_Health"));
			Integer autoHealth = 0;
			for (Entity h : current.getHardpoints()) {
				h = (Hardpoint) h;
				autoHealth = autoHealth + h.calcHealth();
			}
			component2.setText(autoHealth.toString());
		}		
	}
	
	private class BtCalcCombatPowerListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			JTextField component2 = (JTextField) components.get(getPosition("Ai_Combat_Power"));
			JTextField component3 = (JTextField) components.get(getPosition("Autoresolve_Health"));
			JTextField component4 = (JTextField) components.get(getPosition("Damage"));
			
			
			Integer combatPower = Integer.parseInt(component3.getText())+Integer.parseInt(component4.getText());
			component2.setText(combatPower.toString());
		}		
	}
	
	private class BtEditProjListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			isNew=false;
			mainFrame.setVisible(false);
			
			if (isCustom) {
				String file = (String) JOptionPane.showInputDialog(null,
						LoadingPanel.CHOOSEFILE,
						LoadingPanel.CHOOSEPROJFILTER,
						JOptionPane.QUESTION_MESSAGE, null,
						LoadingPanel.files,
						LoadingPanel.files[0]);
				subFrame = new EntityFrame(file, current, null,
						rootPanel);
			} else {

				subFrame = new EntityFrame("Projectiles.xml", current, null,
						rootPanel);
			}
			subFrame.addWindowListener(new WindowCloseListener());	
		}		
	}
	
	private class BtCreateProjListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			isNew=true;
			mainFrame.setVisible(false);
			if (isCustom) {
				String file = (String) JOptionPane.showInputDialog(null,
						LoadingPanel.CHOOSEFILE,
						LoadingPanel.CHOOSEPROJFILTER,
						JOptionPane.QUESTION_MESSAGE, null,
						LoadingPanel.files,
						LoadingPanel.files[0]);
				subFrame = new EntityFrame(file, current, null,
						rootPanel);
			} else {
			subFrame = new EntityFrame("Projectiles.xml",current,null,rootPanel);
			}
			subFrame.addWindowListener(new WindowCloseListener());	
		}		
	}
	
	private class BtEditHardpointListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			isNew=false;
			mainFrame.setVisible(false);
			if (isCustom) {
				String file = (String) JOptionPane.showInputDialog(null,
						LoadingPanel.CHOOSEFILE,
						LoadingPanel.CHOOSEHARDILTER,
						JOptionPane.QUESTION_MESSAGE, null,
						LoadingPanel.files,
						LoadingPanel.files[0]);
				subFrame = new EntityFrame(file, current, null,
						rootPanel);
			} else {
			subFrame = new EntityFrame("Hardpoints.xml",current,current.getHardpoints(),rootPanel);
			}
			subFrame.addWindowListener(new WindowCloseListener());	
		}		
	}
	
	private class BtCreateHardpointListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			isNew=true;
			mainFrame.setVisible(false);
			if (isCustom) {
				String file = (String) JOptionPane.showInputDialog(null,
						LoadingPanel.CHOOSEFILE,
						LoadingPanel.CHOOSEHARDILTER,
						JOptionPane.QUESTION_MESSAGE, null,
						LoadingPanel.files,
						LoadingPanel.files[0]);
				subFrame = new EntityFrame(file, current, null,
						rootPanel);
			} else {
			
			subFrame = new EntityFrame("ConfigData/HpPrototypes.xml",current,null,rootPanel);
			}
			subFrame.addWindowListener(new WindowCloseListener());	
		}		
	}
	
	private class BtCreateUnitAbilityListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			JOptionPane.showMessageDialog(null, LoadingPanel.NOTAVAILABLE);
//			isNew=true;
//			mainFrame.setVisible(false);
//			subFrame = new EntityFrame("UnitAbilitys.xml",current,null,rootPanel);
//			subFrame.addWindowListener(new WindowCloseListener());	
		}		
	}
	
	private class BtEditUnitAbilityListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			JOptionPane.showMessageDialog(null, LoadingPanel.NOTAVAILABLE);
//			isNew=false;
//			mainFrame.setVisible(false);
//			subFrame = new EntityFrame("UnitAbilitys.xml",current,current.getAbilities(),rootPanel);
//			subFrame.addWindowListener(new WindowCloseListener());	
		}		
	}
	
	private class BtCategoryListener implements ActionListener{
		private JDialog jd = new JDialog();
		private JList categories = new JList();
		private JList acategories = new JList();
		private DefaultListModel dlm = new DefaultListModel();
		private DefaultListModel adlm = new DefaultListModel();
		private JTextField component2= (JTextField) components.get(getPosition("CategoryMask")); 
		private JTextField jtf = new JTextField();
		private String categoryMask=component2.getText();
		
		public void actionPerformed(ActionEvent e) {
			JButton add = new JButton ("Hinzufgen");
			add.addActionListener(new AddActionListener() );
			JButton finish = new JButton("Fertig");
			finish.addActionListener(new FinishActionListener());
			
			dlm.removeAllElements();
			adlm.removeAllElements();
			String[] cat = LoadingPanel.categories;
			for(String s : cat){
				s=ListXml.trim(s);
				dlm.addElement(s);
				adlm.addElement("Anti"+s);
			}
//			Character c = ' | ';
			String[] setCategories = categoryMask.split(" | ");
			for(String s2 : setCategories){
				if(!dlm.removeElement(ListXml.trim(s2))&&!adlm.removeElement(ListXml.trim(s2))&&!s2.contains("|")){
					JOptionPane.showMessageDialog(null, "Fehler beim Laden des Elements: "+s2);
				}
			}
			categories.setModel(dlm);
			acategories.setModel(adlm);
			jtf.setText(categoryMask);
			jd.setLayout(new BorderLayout());
			
			jd.add(jtf,BorderLayout.NORTH);
			jd.add(categories,BorderLayout.WEST);
			jd.add(add,BorderLayout.CENTER);
			jd.add(acategories,BorderLayout.EAST);
			jd.add(finish,BorderLayout.SOUTH);
			jd.pack();
			jd.setTitle("CategoryMasks");
			jd.setVisible(true);
			jd.setAlwaysOnTop(true);
			
			
			
			
			
		}	
		
		private class AddActionListener implements ActionListener{
			public void actionPerformed(ActionEvent e) {
				Object[] selectedValues = categories.getSelectedValues();
				Object[] selectedValues2 = acategories.getSelectedValues();
				for(Object o : selectedValues){
					if(categoryMask.equals("")){
						categoryMask = o.toString();
					}
					else{
						categoryMask = categoryMask +" | "+ o.toString();
					}
					dlm.removeElement(o);
				}
				for(Object o : selectedValues2){
					if(categoryMask.equals("")){
						categoryMask = o.toString();
					}
					else{
						categoryMask = categoryMask +" | "+ o.toString();
					}
					adlm.removeElement(o);
				}
				jtf.setText(categoryMask);
				jd.pack();
			}			
		}
		
		private class FinishActionListener implements ActionListener{
			public void actionPerformed(ActionEvent e) {
				
				component2.setText(categoryMask);
				jd.removeAll();
				jd.dispose();
			}			
		}
	}
	
	private class BtBehaviorListener implements ActionListener{
		private JTextField component2;
		private DefaultListModel dlm = new DefaultListModel();
		private LinkedList<String> behaviorNames ;
		private JTextField jtf = new JTextField();
		private JDialog jd = new JDialog();
		private JList behaviorList =  new JList();
		private String endProduct = "";
		private String[] setBehaviors;
		@SuppressWarnings("unused")
		private String type;
		
		public BtBehaviorListener(LinkedList<String> behaviorNames,String type){
			this.behaviorNames=behaviorNames;
			this.type = type;
			component2 = (JTextField) components.get(getPosition(type));
			jtf.setText(component2.getText());
			setBehaviors = component2.getText().split(",");
		}
		
		public void actionPerformed(ActionEvent e) {
			jtf.setEditable(false);
			jd.setLayout(new BorderLayout());
			JButton add = new JButton (LoadingPanel.BTADD);
			add.addActionListener(new AddActionListener() );
			JButton finish = new JButton(LoadingPanel.BTFINISH);
			finish.addActionListener(new FinishActionListener());
			
			dlm.removeAllElements();
			for(String s : behaviorNames){
				dlm.addElement(s);
			}
			for(String s2 : setBehaviors){
				if(!dlm.removeElement(ListXml.trim(s2))){
					JOptionPane.showMessageDialog(null, "Fehler beim Laden des Elements: "+s2);
				}
			}
			behaviorList.setModel(dlm);
			
			jd.setTitle(LoadingPanel.SETBEHAVIOR);
			jd.add(add,BorderLayout.EAST);
			jd.add(behaviorList,BorderLayout.NORTH);
			jd.add(finish,BorderLayout.WEST);
			jd.add(jtf,BorderLayout.SOUTH);
			jd.pack();
			jd.setAlwaysOnTop(true);
			jd.setVisible(true);
		}
		
		private class AddActionListener implements ActionListener{
			public void actionPerformed(ActionEvent e) {
				Object[] selectedValues = behaviorList.getSelectedValues();
				for(Object o : selectedValues){
					if(endProduct.equals("")){
						endProduct = o.toString();
					}
					else{
						endProduct = endProduct +","+ o.toString();
					}
					dlm.removeElement(o);
				}	
				jtf.setText(endProduct);
				jd.pack();
			}			
		}
		
		private class FinishActionListener implements ActionListener{
			public void actionPerformed(ActionEvent e) {
				
				component2.setText(endProduct);
				jd.removeAll();
				jd.dispose();
			}			
		}
		
	}
	
	private class BtPlanetListener implements ActionListener{
		JTextField component2 = (JTextField) components.get(getPosition("Required_Planets"));
		JList planetList =  null;
		JComboBox letterChooser = null;
		ListXml lx = new ListXml("Planets.xml");
		DefaultListModel dlm = new DefaultListModel();
		String planetNames = component2.getText();
		JTextField jtf = new JTextField();
		JDialog jd = new JDialog();
		public void actionPerformed(ActionEvent e) {
			
			initPlanetChooser();
		}

		private String initPlanetChooser() {
			jtf.setEditable(false);
			LinkedList<Character> letters = new LinkedList<Character>();
			for(int i=0;i<26;i++){
				Character c = (char) ('A'+i);
				letters.add(c);
			}
			jd.setLayout(new BorderLayout());
			letterChooser  = new JComboBox(letters.toArray());
			letterChooser.addItemListener(new SelectLetterListener());
			getPlanets();
			JButton add = new JButton (LoadingPanel.BTADD);
			add.addActionListener(new AddActionListener() );
			JButton finish = new JButton(LoadingPanel.BTFINISH);
			finish.addActionListener(new FinishActionListener());
			
			
			jd.setTitle("Planeten setzen");
			jd.add(letterChooser,BorderLayout.NORTH);
			jd.add(add,BorderLayout.EAST);
			jd.add(planetList,BorderLayout.CENTER);
			jd.add(finish,BorderLayout.WEST);
			jd.add(jtf,BorderLayout.SOUTH);
			jd.pack();
			jd.setAlwaysOnTop(true);
			jd.setVisible(true);
			
			return planetNames;
		}
		
		private void getPlanets(){
			LinkedList<Element> planets = ListXml.findAllElementsBeginningWith(letterChooser.getSelectedItem().toString(), lx.getElements());
			dlm.removeAllElements();
			for(Element e : planets){
				dlm.addElement(e.getAttributeValue("Name"));
			}	
			if(planetList!=null){
				planetList.setModel(dlm);
			}
			else{
			planetList = new JList(dlm);
			}
		}
		
		private class SelectLetterListener implements ItemListener{
			public void itemStateChanged(ItemEvent e) {
				getPlanets();		
				jd.pack();		
			}			
		}
		
		private class AddActionListener implements ActionListener{
			public void actionPerformed(ActionEvent e) {
				Object[] selectedValues = planetList.getSelectedValues();
				for(Object o : selectedValues){
					if(planetNames.equals("")){
						planetNames = o.toString();
					}
					else{
					planetNames = planetNames +","+ o.toString();
					}
				}	
				jtf.setText(planetNames);
				jd.pack();
			}			
		}
		
		private class FinishActionListener implements ActionListener{
			public void actionPerformed(ActionEvent e) {
				
				component2.setText(planetNames);
				jd.dispose();
			}			
		}		
	}
	
	private class SelectEntityListener implements ActionListener{

		public void actionPerformed(ActionEvent e) {
			current = (Entity) entityDropDown.getSelectedItem();
			createSpecialCases();
			fillComponents();
			
		}
		
	}
	
	private class BtSaveListener implements ActionListener{

		public void actionPerformed(ActionEvent e) {

			if(isHardpoint){
				if(rootPanel.isNew){
					String name = JOptionPane.showInputDialog(LoadingPanel.ENTERNAME);
					while(ens.nameAlreadyUsed(name)){
						name = JOptionPane.showInputDialog(LoadingPanel.NAMEALREADYINUSE);						
					}
					current.setName(name);
					if (isCustom) {
						String file = (String) JOptionPane.showInputDialog(null,
								LoadingPanel.CHOOSEFILE,
								LoadingPanel.CHOOSEHARDILTER,
								JOptionPane.QUESTION_MESSAGE, null,
								LoadingPanel.files,
								LoadingPanel.files[0]);
						subFrame = new EntityFrame(file, current, null,
								rootPanel);
					} else {
					current.setFile("Hardpoints.xml");
					}
					getContent();
					ens.addEntity(current);
					LinkedList<String> hardpointNames = topEnt.getHardpointNames();
					hardpointNames.add(current.toString());
					String hardpoints="";
					for (int i = 0; i < hardpointNames.size(); i++) {
						if (i < hardpointNames.size() - 1)
							hardpoints = hardpoints.concat(hardpointNames.get(i) + ",");
						else
							hardpoints = hardpoints.concat(hardpointNames.get(i));
					}
					JTextField component2 = (JTextField) rootPanel.components.get(rootPanel.getPosition("HardPoints"));
					component2.setText(hardpoints);
				}
				else{
					getContent();
					ens.setEntity(current);
					
				}
//				if(isAbility){
//				getContent();
//				topEnt.setAbility(current.toElement());
//				int pos = rootPanel.getPosition("Unit_Abilities_Data");
//				if (pos != -1 && rootPanel.isNew) {
//					JComboBox jcb = (JComboBox) rootPanel.components.get(pos);
//					jcb.addItem(current);
//				}
//				
//			}
				
			}
			if(isProjectile){
				if(rootPanel.isNew){
					String name = JOptionPane.showInputDialog(LoadingPanel.ENTERNAME);
					while(ens.nameAlreadyUsed(name)){
						name = JOptionPane.showInputDialog(LoadingPanel.NAMEALREADYINUSE);						
					}
					current.setName(name);
					if (isCustom) {
						String file = (String) JOptionPane.showInputDialog(null,
								LoadingPanel.CHOOSEFILE,
								LoadingPanel.CHOOSEPROJFILTER,
								JOptionPane.QUESTION_MESSAGE, null,
								LoadingPanel.files,
								LoadingPanel.files[0]);
						subFrame = new EntityFrame(file, current, null,
								rootPanel);
					} else {
					current.setFile("Projectiles.xml");
					}
					getContent();
					ens.addEntity(current);
					JComboBox component2 = (JComboBox) rootPanel.components.get(rootPanel.getPosition("HardPoints"));
					component2.addItem(current);
					component2.setSelectedItem(current);
				}
				else{
					getContent();
					ens.setEntity(current);
					
				}
			}
			if(isSpaceUnit||isGroundUnit||isHeroUnit||isCustom){
				getContent();
				ens.setEntity(current);
			}
			JOptionPane.showMessageDialog(null, LoadingPanel.SAVESUCCES);
			
		}
		
	}
	
	private class BtCreateListener implements ActionListener{

		public void actionPerformed(ActionEvent e) {
			String name = JOptionPane.showInputDialog(LoadingPanel.ENTERNAME);
			while(ens.nameAlreadyUsed(name)){
				name = JOptionPane.showInputDialog(LoadingPanel.NAMEALREADYINUSE);						
			}
			Entity newE = current.clone();
			current = newE;
			current.setName(name);
			current.setFile(file);
			getContent();
			ens.addEntity(current);
			entityDropDown.addItem(current);
			
		}
		
	}
	
	
	
	private class WindowCloseListener implements WindowListener{

		public void windowActivated(WindowEvent e) {
		}

		public void windowClosed(WindowEvent e) {
			
			
		}

		public void windowClosing(WindowEvent e) {
			subFrame.getEntities().createXml(subFrame.getEntities().getRoot(),subFrame.getTitle());
			e.getWindow().dispose();
			mainFrame.setVisible(true);			
		}

		public void windowDeactivated(WindowEvent e) {
			// TODO Auto-generated method stub
			
		}

		public void windowDeiconified(WindowEvent e) {
			// TODO Auto-generated method stub
			
		}

		public void windowIconified(WindowEvent e) {
			// TODO Auto-generated method stub
			
		}

		public void windowOpened(WindowEvent e) {
			// TODO Auto-generated method stub
			
		}
		
	}

	
	
}
