package xmlFilter;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;



public class AddXmlFilterFrame extends JFrame {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6498126915754695235L;

	private String[] buildAttributes = { "Build_Cost_Credits",
			"Build_Time_Seconds", "Required_Special_Structures", "Tech_Level",
			"Required_Star_Base_Level" };

	private String[] aiAttributes = { "Damage", "AI_Combat_Power",
			"Autoresolve_Health", "Encyclopedia_Good_Against",
			"Encyclopedia_Vulnerable_To" };

	private String[] fireInAttributes = { "Fire_Inaccuracy_Distance" };

	private String[] moveAttributes = { "Max_Speed", "Max_Rate_Of_Turn",
			"Max_Rate_Of_Roll" };

	private String[] healthAttributes = { "Shield_Points",
			"Shield_Refresh_Rate", "Tactical_Health" };

	private String[] rangeAttributes = { "Targeting_Max_Attack_Distance",
			"Space_FOW_Reveal_Range" };

	private String[] hardpointsAttributes = { "HardPoints" };

	private String[] hardpointAttributes = { "Type", "Is_Targetable",
			"Is_Destroyable", "Tooltip_Text", "Health",
			"Death_Explosion_Particles", "Death_Explosion_SFXEvent",
			"Attachment_Bone", "Collision_Mesh", "Damage_Decal",
			"Damage_Particles", "Damage_Type", "Fire_Bone_A", "Fire_Bone_B",
			"Fire_Cone_Width", "Fire_Cone_Height", "Fire_Projectile_Type",
			"Fire_Min_Recharge_Seconds", "Fire_Max_Recharge_Seconds",
			"Fire_Pulse_Count", "Fire_Pulse_Delay_Seconds",
			"Fire_Range_Distance", "Fire_SFXEvent", "Fire_Inaccuracy_Distance",
			"Fire_Inaccuracy_Distance", "Fire_Inaccuracy_Distance",
			"Fire_Inaccuracy_Distance", "Fire_Inaccuracy_Distance",
			"Fire_Inaccuracy_Distance", "Fire_Inaccuracy_Distance", };
	

	private String[] graphicalAttributes = { "Space_Model_Name",
			"Scale_Factor", "Space_Layer", "Layer_Z_Adjust", "Death_Clone" };
	
	private JTabbedPane addFilterPanel;
	private int dim = 9;
	private DefaultListModel[] listModels = new DefaultListModel[dim];
	private JList[] filterLists = new JList[dim] ;
	private LinkedList<String[]> attributes = new LinkedList<String[]>();
	private String[] filterLbs= new String[9];
	private JButton btSave = new JButton("Speichern");
	private JPanel savePanel = new JPanel();
	private JFrame thisFrame = this;
	
	public AddXmlFilterFrame(){
		this.setTitle("Eigenen Filter erstellen");
		this.setLayout(new BorderLayout());
		addFilterPanel = new JTabbedPane();
		addFilterPanel.setPreferredSize(new Dimension(1000,200));
        addLists();
        btSave.addActionListener(new btSaveActionListener());
        btSave.setToolTipText("Filter zusammenstellen");
		savePanel.add(btSave);
		this.add(addFilterPanel,BorderLayout.NORTH);
        this.add(savePanel,BorderLayout.CENTER);
		this.pack();
		this.setAlwaysOnTop(true);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setVisible(true);
	}
	
	private void addLists(){
		addAllAttributes();
		Iterator it = attributes.iterator();
		
		for (int j = 0;j<9;j++){
			String[] temp = (String[])it.next();
			listModels[j]=new DefaultListModel();
			
			for(String s : temp){
				listModels[j].addElement(s);
			}
			filterLists[j] = new JList(listModels[j]);
			addFilterPanel.addTab(filterLbs[j],new JScrollPane(filterLists[j]));
		}
		
	}
	private void addAllAttributes(){
		attributes.add(buildAttributes);
		attributes.add(aiAttributes);
		attributes.add(fireInAttributes);
		attributes.add(moveAttributes);
		attributes.add(healthAttributes);
		attributes.add(rangeAttributes);
		attributes.add(hardpointsAttributes);
		attributes.add(hardpointAttributes);
		attributes.add(graphicalAttributes);
		
		filterLbs[0]=new String("Bau");
		filterLbs[1]=new String("Ki");
		filterLbs[2]=new String("Inaccuracy");
		filterLbs[3]=new String("Bewegungs");
		filterLbs[4]=new String("Gesundheits");
		filterLbs[5]=new String("Reichweite");
		filterLbs[6]=new String("Hardpoint");
		filterLbs[7]=new String("Hardpointattribute");
		filterLbs[8]=new String("Grafisch");
		
	}
	
	private class btSaveActionListener implements ActionListener{

		public void actionPerformed(ActionEvent arg0) {
			String file=null;
			LinkedList<String> filterAttr = new LinkedList<String>();
			String filterName = JOptionPane.showInputDialog( "Bitte Namen des Filters angeben" );
			String filterType = JOptionPane.showInputDialog( "Bitte Typ des Filters angeben" );
			if(filterType.equals("Hardpoint")){
				file="HpFilters.xml";
			}
			if(filterType.equals("Einheit")){
				file="ShipFilters.xml";
			}
			if(filterType.equals("Neu")){
				file="NewFilters.xml";
			}
			if(filterType.equals("NeuHP")){
				file="NewHpFilters.xml";
			}
			for(JList jl : filterLists){
				Object[] temp = jl.getSelectedValues();
				for( Object s : temp){
					filterAttr.add(s.toString());
				}				
			}
			XmlFilterManager fm = new XmlFilterManager(file);
			System.out.println(filterName + filterAttr + file);
			fm.addFilter(filterName, filterAttr, file);
			thisFrame.dispose();
		}
		
	}

}
