package xmlFilter;

import java.util.LinkedList;

import misc.ProcessXML;

import org.jdom.Element;

import xmlFilter.XmlFilterManager;

public class XmlFilter {
	
	
	private Element currentFilter;
	private String[] filterElements;
	private String name;
	private String file;
	
	
	public XmlFilter (String name, String file){
		this.file = file;
		this.name= name;
		XmlFilterManager fm = new XmlFilterManager(file);
		currentFilter = fm.getFilter(name,this.file);
		LinkedList<String> temp = new LinkedList<String>();
		for(Object o : currentFilter.getChildren()){
			Element e = (Element) o;
			temp.add(e.getText());			
		}
		filterElements = new String[temp.size()];
		temp.toArray(filterElements);
	}
	

	
	public String[] getFilter(){
		return this.filterElements;		
	}
	
	public String getName(){
		return this.name;
	}
	
	public String toString(){
		return this.file;
	}
	
	public static void writeXml(LinkedList<String> names){
		ProcessXML px = new  ProcessXML("FilterConfig.xml");
		Element root = px.getRoot();
		root.removeContent();
		LinkedList<Element> configs = new LinkedList<Element>();
		for(String s : names){
			Element element = new Element(s);
			element.setText(s);
			configs.add(element);
		}
		root.addContent(configs);
		ProcessXML.writeXML(root, "FilterConfig.xml");
	}
	
	
	

}
