package xmlFilter;

import java.util.LinkedList;

import misc.ListXml;
import misc.ProcessXML;

import org.jdom.Attribute;
import org.jdom.Element;

public class XmlFilterManager {
	

	private Element root;
	private String file;
	private ListXml lx;
	
	public XmlFilterManager(String file){
		this.file=file;
	}
	
	public void removeFilter(String name){
		root.removeChild(name);
	}
		
	@SuppressWarnings("unchecked")
	public LinkedList<Element> getAllFilters(String file){
		this.file = file;
		lx = new ListXml(file);
		root= lx.getRoot();
		LinkedList<Element> temp = new LinkedList<Element>();
		temp.addAll(root.getChildren());
		return temp;
	}
	
	public void addFilter(String filterName,Iterable<String> filterAttr,String file) {
		@SuppressWarnings("unused")
		ProcessXML px = new ProcessXML(file);
		lx = new ListXml(this.file);
		root= lx.getRoot();
		root.removeContent();
		Element filterRoot = new Element("Filter");
		String names = "Attribute_";
		filterRoot.setAttribute(new Attribute("Name",filterName));
		int i = 1;
		for (String s : filterAttr){
			Element temp = new Element(names+(i++));
			temp.setText(s);
			filterRoot.addContent(temp);
		}
		root.addContent(filterRoot);
		ProcessXML.writeXML(root, file);
	}
	
	public Element getFilter(String name, String file){
		this.file=file;
		lx = new ListXml(file);
		return ListXml.findSpecificElementWithName(name, lx.getElements());
	}

	public void clearFilter(String file) {
		@SuppressWarnings("unused")
		ProcessXML px = new ProcessXML(file);
		lx = new ListXml(this.file);
		root= lx.getRoot();
		root.removeContent();		
	}

}
